package Vulture;
our $VERSION = '0.9';

BEGIN {
    use Exporter ();
    @ISA = qw(Exporter);
    @EXPORT_OK = qw($proto &get_app $auth_server_name $auth_url &session &get_cookie &read_conf &init $db_uri);
}

use strict;
use warnings;

use Apache::Session::Generate::MD5;
use Apache::Session::Flex;
use DBI;

use Data::Dumper;

our ($proto, $auth_server_name, $auth_url, $db_uri, $conf);

sub	session {
	my ($session, $id) = @_;
    
	tie %$session,'Apache::Session::Flex',$id,{
						   Store => 'MySQL',
						   Lock  => 'Null',
						   Generate => 'MD5',
						   Serialize => 'Base64',
						   DataSource => 'dbi:SQLite:dbname=/opt/INTRINsec/VultureNG/sql/sessions'
						  };
}

sub	get_cookie {
	my $cookie = shift;
	my $expression = shift;
	my $ret;
	
	return 0 if !$cookie or !$expression;

	if (UNIVERSAL::isa($expression, "ARRAY")) {
		foreach ($expression) {
			if ($ret = get_cookie($cookie, $_)) {
				return $ret;
			}
		}
	}
	if (UNIVERSAL::isa($cookie, "ARRAY")) {
		foreach ($cookie) {
			if ($ret = get_cookie($_, $expression)) {
				return $ret;
			}
		}
	}
	
	($ret) = ($cookie =~ /$expression/);
	return $ret; 
}

sub	_get_app {
    my ($dbh, $row) = @_;

    my $headers;

    my $sth = $dbh->prepare("SELECT var, value FROM headers, app WHERE id_app='".@$row[0]."' AND app.id='".@$row[0]."' AND app.has_headers='t'");
    $sth->execute;
    while (my ($var, $value) = $sth->fetchrow) {
	$headers->{$var} = $value;
    }
    return {
	'id'                    => @$row[0],
	'url'                   => @$row[3],
	'sso_forward_type'      => @$row[4],
	'is_post'               => @$row[5],
	'post_url'              => @$row[6],
	'auth'                  => @$row[7],
	'rewrite'               => @$row[8],
	'basic'                 => @$row[9],
	'auth_type'             => @$row[10],
	'up'	                => @$row[11],
	'headers'		=> $headers,
    };
}

sub	get_app {
	my ($host, $dbh, $intf) = @_;

	my $all = $dbh->selectall_arrayref("SELECT app.id, app.name, alias, url, sso_forward_type, is_post, post_url, auth, rewrite, basic, type, up".
					   " FROM app, auth, if WHERE app.auth=auth.id OR app.auth='0' AND app.if='$intf' AND if.id='$intf'");
	foreach my $row (@$all) {
	    if (@$row[1] eq $host) {
		return _get_app($dbh, $row);
	    }
	}
	foreach my $row (@$all) {
	    foreach my $als (split (/,/, @$row[2])) {
		$als =~ s|\\\\|\\|g;
		if ($host =~ /$als/) {
		    return _get_app($dbh, $row);
		}
	    }
	}
}

sub	init {
	$proto			= shift;
	$auth_server_name	= shift;
	my  $port		= shift;

	$db_uri			= shift;	
	$auth_url		= $proto."://".$auth_server_name.":".$port;
}

1;
