package Vulture::ResponseHandler;

use strict;
use warnings;

use Apache2::Const -compile => qw(OK REDIRECT FORBIDDEN);
use Apache2::RequestRec ();
use Apache2::RequestIO ();
use HTTP::Request;
use Apache2::RequestUtil();
use APR::Table;
use Net::LDAP;
use MIME::Base64;
use CGI qw/:standard/;

use Vulture qw($db_uri $auth_url $auth_server_name $proto &get_app &session &get_cookie);

sub auth {
    my ($id_auth, $dbh, $user, $pass) = @_;

    my $sth = $dbh->prepare("SELECT id_auth, type FROM auth WHERE id='$id_auth'");
    $sth->execute();
    my $type;
    ($id_auth, $type) = $sth->fetchrow;
    
    if ($type == 2) {
	    return 1;
    }
    
    return 0 if (!$user or !$pass);

    if ($type == 3) {
	$sth = $dbh->prepare("SELECT uri, db_user, db_pass, table_name, login_column, password_column, is_acl FROM sql WHERE id='$id_auth'");
	$sth->execute();
	my ($uri, $db_user, $db_pass, $table_name, $login_column, $password_column, $is_acl) = $sth->fetchrow;
	my $cnx = DBI->connect($uri, $db_user, $db_pass);
	$sth = $cnx->prepare("SELECT count(*) FROM ".$table_name." WHERE ".$login_column."='".$user."' AND ".$password_column."='".$pass."'");
	$sth->execute;
	if (($sth->fetchrow)) {
	    if ($is_acl==1) {
		$sth = $dbh->prepare("SELECT count(*) FROM acl WHERE pass='1' AND user_id='".$user."' AND auth_id='".$id_auth."'");
		$sth->execute;
		if (($sth->fetchrow)) {
		    return 1;
		}
		return 0;
	    }
	    return 1;
	}
    }

    if ($type == 1) {
	$sth = $dbh->prepare("SELECT ldap_addr, ldap_port, ldap_dn, ldap_password, ldap_base_dn, ldap_user_attr, ldap_group_attr, ldap_group_member, is_acl, ldap_group_is_dn FROM ldap WHERE id='$id_auth'");
	$sth->execute;
	my ($ldap_server, $ldap_port, $ldap_bind_dn, $ldap_bind_password, $ldap_base_dn, $ldap_uid_attr, $ldap_group_attr, $ldap_group_member, $is_acl, $ldap_group_is_dn) = $sth->fetchrow;
	my $ldap = Net::LDAP->new($ldap_server, port => $ldap_port);
	$ldap->bind($ldap_bind_dn, password => $ldap_bind_password);
	my $mesg = $ldap->search(base   => $ldap_base_dn,
				 filter => "(" . $ldap_uid_attr . "=" . $user . ")"
				 );
	$mesg->code and return 0;
	my $object = $mesg->entry(0) or return 0;
	my $dnuser = $object->dn;
	my $result = $ldap->bind($dnuser, password => $pass);
	if (!$result->code) {
	    if ($is_acl==1) {
		$sth = $dbh->prepare("SELECT count(*) FROM acl WHERE user_id='".$user."' AND auth_id='".$id_auth."'");
		$sth->execute;
		if (($sth->fetchrow)) {
		    return 1;
		}
		my $sql = "SELECT group_id FROM acl WHERE group_id != '' AND auth_id='".$id_auth."'";
		$sth = $dbh->prepare($sql);
		$sth->execute;
		if (!($sth->fetchrow)) {
                    return 0;
                }

		my $filter_groups;
		while (my ($group) = $sth->fetchrow) {
		    $filter_groups .= "(".$ldap_group_attr."=".$group.")";
		}

		my $filter_member;
		if ($ldap_group_is_dn) { # Active Directory
		    $filter_member = $ldap_group_member . "=" . $dnuser;
		}
		else {
		    $filter_member = $ldap_uid_attr . "=" . $user;
		}
		my $mesg = $ldap->search(base   => $ldap_base_dn,				     
					 filter => "(&(|(objectclass=posixGroup)(objectclass=group))(|".$filter_groups.")(".$filter_member."))"
					 );
		$mesg->code and return 0;
		my $object = $mesg->entry(0);
		$ldap->unbind;

		if ($object and $object->dn) {
			return 1;
		}
                return 0;
	    }
	    return 1;
	}
    }
    0;
}

sub post {
    my ($id_app, $dbh, $user, $pass) = @_;
    
    my $ret;
    my $sth = $dbh->prepare("SELECT sso_forward_type, autologon FROM app WHERE id='".$id_app."'");
    $sth->execute;
    my ($sso_forward_type, $autologon) = $sth->fetchrow;
    if ($sso_forward_type eq "basic") {
	if ($autologon eq "t") {
		$ret = "Basic " . encode_base64($user . ':' . $pass) if ($user && $pass);
		return $ret;
	}

	my $sql = "SELECT value FROM profile WHERE id_app='".$id_app."' AND user='".$user."' AND field_var='vulture_login'";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	my ($vulture_login) = $sth->fetchrow;
	$sql = "SELECT value FROM profile WHERE id_app='".$id_app."' AND user='".$user."' AND field_var='vulture_password'";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	my ($vulture_password) = $sth->fetchrow;
	$ret = "Basic " . encode_base64($vulture_login . ':' . $vulture_password) if ($vulture_login && $vulture_password);
    }
    else {
	if ($autologon eq "t") {
		$sth = $dbh->prepare("SELECT field_var, field_type, field_value FROM post WHERE id_app='".$id_app."'");
        	$sth->execute;
        	while (my ($var,$type,$value) = $sth->fetchrow) {
			if ($type eq "autologon_user") {
				$value = $user;
			}
			if ($type eq "autologon_password") {
			 	$value = $pass;
			}
			$ret .= $var."=".$value."&";
		}
		return $ret;
	}
	my $sql = "SELECT field_var, value FROM profile WHERE id_app='".$id_app."' AND user='".$user."'";
	my $sth = $dbh->prepare($sql);
	$sth->execute;
	while (my ($var, $val) = $sth->fetchrow) {
	    $ret .= $var."=".$val."&";
	}
    }
    $ret;
}

sub register {
    my ($id_app, $dbh, $user, $pass) = @_;

    my $sth = $dbh->prepare("SELECT sso_forward_type, autologon FROM app WHERE id='".$id_app."'");
    $sth->execute;
    my ($sso_forward_type,$autologon) = $sth->fetchrow;
    if ($sso_forward_type eq "basic" && $autologon eq "f") {
	$sth = $dbh->prepare("INSERT INTO profile (id_app, user, field_var, value) VALUES('$id_app', '$user', 'vulture_login', '".param('vulture_login')."')");
	$sth->execute;
	$sth = $dbh->prepare("INSERT INTO profile (id_app, user, field_var, value) VALUES('$id_app', '$user', 'vulture_password', '".param('vulture_password')."')");
	$sth->execute;
    }
    elsif ($autologon eq "f") {
	$sth = $dbh->prepare("SELECT field_var FROM post WHERE id_app='".$id_app."'");
	$sth->execute;
	while (my ($var) = $sth->fetchrow) {
	    my $insert = $dbh->prepare("INSERT INTO profile (id_app, user, field_var, value) VALUES('$id_app', '$user', '".$var."', '".param($var)."')");
	    $insert->execute;
	}
    }
    return post($id_app, $user, $pass);
}

sub get_redirect {
    my ($url) = @_;

    my $redirect = <<EOF
<html>
<head>
<meta http-equiv="refresh" content="0;url=$url">
</head>
</html>
EOF
;
}

sub app_form {
    my ($id_app, $dbh, $url) = @_;

    open(FH, "< /opt/INTRINsec/VultureNG/conf/$id_app.tpl")
	 or open(FH, "< /opt/INTRINsec/VultureNG/conf/default.tpl");
    my $html;
    while (<FH>) {
	$html .= $_;
    }
    close(FH);
    my $sth = $dbh->prepare("SELECT name, sso_forward_type FROM app WHERE id='".$id_app."'");
    $sth->execute;
    my ($name, $sso_forward_type) = $sth->fetchrow;    

    my $form = <<EOF
<table>
<form method="POST" action="$url">
EOF
;   
    if ($sso_forward_type eq "basic") {
	$form .= <<EOF
<tr><td>Utilisateur</td><td><input type="text" name="vulture_login"></td></tr>
<tr><td>Mot de passe</td><td><input type="password" name="vulture_password"></td></tr>
EOF
;
    }
    elsif ($sso_forward_type eq "post") {
	my $sth = $dbh->prepare("SELECT field_desc, field_var, field_value, field_type FROM post WHERE id_app='".$id_app."' AND field_type != 'autologon_user' AND field_type != 'autologon_password'");
	$sth->execute;
	while (my ($desc, $var, $default, $type) = $sth->fetchrow) {
	    $desc    =~ s/\\//g;
	    $var     =~ s/\\//g;
	    $default =~ s/\\//g;

	    if ($type eq "hidden") {
		$form .= <<EOF
<input type="hidden" name="$var" value="$default">
EOF
;
	    }
	    else {
		$form .= <<EOF
<tr><td>$desc</td><td><input type="$type" name="$var" value="$default"></td></tr>
EOF
;
	    }
	}
    }
    $form .= <<EOF
<tr><td></td><td align="right"><input type="submit"></td></tr>
</form>
</table>
EOF
;
    $html =~ s/__FORM__/$form/xm;
    $html =~ s/__APP_NAME__/$name/xm;
    return $html;
}

sub handler {
	my $r = shift;

	my $dbh = DBI->connect($db_uri); 
	if ($r->hostname eq $auth_server_name and $r->uri ne "/favicon.ico") {

		if ((my ($cookie_id) = get_cookie($r->headers_in->{Cookie}, 'vulture=([^;]*)'))) {
			my ($new_id) = ($r->args =~ /vulture=(.*)/);
			my %proxy;
			session(\%proxy, $cookie_id);

			my %session;
			session(\%session, $new_id);
			my $app = get_app($session{site}, $dbh, $r->dir_config('if_id'));

			if ($proxy{$app->{auth}}) {
				my $post;

				if ($app->{is_post}) {
					if ($r->method eq "POST") {
						$post = register($app->{id}, $dbh, $proxy{$app->{auth}}->{user}, $proxy{$app->{auth}}->{pass});
					}
					else {
						$post = post($app->{id}, $dbh, $proxy{$app->{auth}}->{user}, $proxy{$app->{auth}}->{pass});
					}
				}

				if (!$app->{is_post} or ($app->{is_post} and $post)) {
					chomp($post);
					$post ||= 1;
					$session{post} = $post;
					$r->headers_out->set('Location' => $proto."://". $session{site} . ":".$session{port}. $session{uri});
					$r->status(Apache2::Const::REDIRECT);
					return Apache2::Const::OK;
				}
				else {
					$session{$post} = undef;
					$r->status(200);
					$r->content_type('text/html');
					$r->print(app_form($app->{id}, $dbh, "$auth_url/?vulture=$new_id"));
					return Apache2::Const::OK;
				}
			}
		}

		my ($id) = ($r->args =~ /vulture=(.*)/);
		my %session;
		session(\%session, $id);
		my $app = get_app($session{site}, $dbh, $r->dir_config('if_id'));

	        my ($auth, $user, $pass);
		if ($r->headers_in->{Authorization} and $r->headers_in->{Authorization} =~ /Basic\s+(.*)/) {
			($user, $pass) = split(':', decode_base64($1));
		}
		$auth = auth($app->{auth}, $dbh, $user, $pass);
		if ($auth) {
			my %proxy;
			session(\%proxy);
			$proxy{$app->{auth}} = {
				'user' => $user,
				'pass' => $pass,
			};
			$r->headers_out->set('Set-Cookie' => "vulture=". $proxy{_session_id} . "; path=/");
		}
		if (!$app->{auth} or $auth) { # If exit status is 0 user is authen
			my $url = $proto."://".$session{site}.":".$session{port} . $session{uri};
			$r->content_type('text/html');
			$r->print(get_redirect($url));
			$r->status(200);
			return Apache2::Const::OK;
		}
		$r->status(401);
		$r->headers_out->set('WWW-Authenticate' => 'Basic realm="vulture"');
		return Apache2::Const::OK;
	}

	my $app = get_app($r->hostname, $dbh, $r->dir_config('if_id'));

	if ($app and $r->uri ne "/favicon.ico") {
		if (!$app->{up}) {
			open(FH, "< /opt/INTRINsec/VultureNG/conf/".$app->{id}.".unavailable.tpl")
			or open(FH, "< /opt/INTRINsec/VultureNG/conf/unavailable.tpl");
			my $html;
			while (<FH>) {
				$html .= $_;
			}
			close(FH);
			$html =~ s/__APP_NAME__/$r->hostname/xm;
			$r->status(200);
			$r->content_type('text/html');
			$r->print($html);
			return Apache2::Const::OK;
		}

		if ((my ($cookie_id) = get_cookie($r->headers_in->{Cookie}, 'vulture=([^;]*)'))) {
			my %session;
			session(\%session, $cookie_id);
		
			if ($session{post}) {
				$r->headers_out->set('Location' => $proto."://". $r->hostname .":".$r->get_server_port ."/");
				$r->status(Apache2::Const::REDIRECT);
				return Apache2::Const::OK;
			}
		}

		my %session;
		session(\%session);
		my $id = $session{_session_id};
		$session{site} = $r->hostname;
		$session{port} = $r->get_server_port;
		$session{uri} = $r->uri;

		my $url = $auth_url . "/?vulture=". $id;

		$r->headers_out->set('Set-Cookie' => "vulture=". $id . "; path=/");
		$r->status(200);
		$r->content_type('text/html');
		$r->print(get_redirect($url));
		return Apache2::Const::OK;
	}
	return Apache2::Const::FORBIDDEN;
}

1;
