<?

include_once "UserSQL.php";
include_once "UserLDAP.php";
include_once "GroupLDAP.php";

define('SQL',		1);
define('LDAP_USR',	2);
define('LDAP_GRP',	3);

/*

  TODO: Manage a cache

*/

class ACL {
	function setAuth($db, $id) {
		$this->auth_db = $db;
		$this->auth_id = $id;
	}

	function getAuth() {
		$auth['db'] = $this->auth_db;
		$auth['id'] = $this->auth_id;
		return $auth;
	}

	function getPass($id, $is_grp) {
		$auth = $this->getAuth();
		$db = $auth['db'];
		
		if ($is_grp)
			$result = $db->query("SELECT pass FROM acl WHERE group_id='".sqlite_escape_string($id)."' AND auth_id='".sqlite_escape_string($auth['id'])."'");
		else
			$result = $db->query("SELECT pass FROM acl WHERE user_id='".sqlite_escape_string($id)."' AND auth_id='".sqlite_escape_string($auth['id'])."'");
		$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
		return $row['pass'];
	}

	function setPass($id, $pass, $is_grp) {
		$auth = $this->getAuth();
		$db = $auth['db'];

		if ($is_grp)
			$db->query("DELETE FROM acl WHERE group_id='".$id."' AND auth_id='".$auth['id']."'");
		else
			$db->query("DELETE FROM acl WHERE user_id='".$id."' AND auth_id='".$auth['id']."'");

		if ($pass) {
			if ($is_grp)				
				$db->query("INSERT INTO acl (auth_id, group_id, pass) VALUES ('".$auth['id']."', '".$id."', '".$pass."')");
			else
				$db->query("INSERT INTO acl (auth_id, user_id, pass) VALUES ('".$auth['id']."', '".$id."', '".$pass."')");
		}
	}

	function setACL($ids, $pass, $type) {
		if ($type == SQL) {
			$cnx = $this->getSQLCnx();
		}
		elseif ($type == LDAP_USR) {
			$cnx = $this->getLDAPCnx();
		}
		foreach ($ids as $id) {
			if ($type == SQL) {
				$u = new UserSQL();
				$u->select($id, $this->getAuth(), $cnx);
				$this->setPass($u->getID(), $pass, 0);
			}
			if ($type == LDAP_USR) {
				$u = new UserLDAP();
				$u->select($id, $this->getAuth(), $cnx);
				$this->setPass($u->getID(), $pass, 0);
			}
			if ($type == LDAP_GRP) {
				$g = new GroupLDAP();
				$g->select($id, $this->getAuth(), $cnx);
				$this->setPass($g->getID(), $pass, 1);
			}
			/* TODO : catch error when type is invalid */
		}
	}

	function getSQLIDs($cnx) {
		$auth = $this->getAuth();
		$sql = new SQL();
		$sql->select($auth['db'], $auth['id']);
		$query = "SELECT " . $sql->getLoginColumn() . " FROM " . $sql->getTableName();
		$result = $cnx->query($query);
		if (DB::isError ($result)) {
			return $ret;
		}
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			$ret[] = $row[$sql->getLoginColumn()];
		}
		return $ret;
	}

	function getSQLCnx() {
		$auth = $this->getAuth();
		$sql = new SQL();
		$sql->select($auth['db'], $auth['id']);
		if ($sql->getDbType() == "SQLite")
			$dsn['phptype'] = 'sqlite';
		elseif ($sql->getDbType() == "Pg")
			$dsn['phptype'] = 'pgsql';
		else
			$dsn['phptype'] = $sql->getDbType();
		if ($sql->getDbHost())
			$dsn['hostspec'] = $sql->getDbHost();
		if ($sql->getDbPort())
			$dsn['port'] = $sql->getDbPort();
		$dsn['database'] = $sql->getDbName();
                $dsn['username'] = $sql->getDbUser();
                $dsn['password'] = $sql->getDbPassword();
		$cnx =& DB::connect($dsn);
		if (DB::isError($cnx)) {
			return FALSE;
		}
		return $cnx;
	}

	function getLDAPUsers($cnx) {
		$auth = $this->getAuth();
		$ldap = new LDAP();
		$ldap->select($auth['db'], $auth['id']);
		$search = ldap_search($cnx, $ldap->getBaseDN(), "(|(objectclass=posixAccount)(objectclass=inetOrgPerson)(objectclass=person))");
		ldap_sort($cnx, $search, $ldap->getUserAttr());
		$result = ldap_get_entries ($cnx, $search);
		for ($user = 0; $user < $result["count"]; $user++) {
			if ($result[$user][$ldap->getUserAttr()][0])
				$ret[] = $result[$user][$ldap->getUserAttr()][0];
		}
		return $ret;
	}

	function getLDAPGroups($cnx) {
		$auth = $this->getAuth();
		$ldap = new LDAP();
		$ldap->select($auth['db'], $auth['id']);
		$search = ldap_search($cnx, $ldap->getBaseDN(), "(|(objectclass=posixGroup)(objectclass=group))");
		ldap_sort($cnx, $search, $ldap->getGroupAttr());
		$result = ldap_get_entries($cnx, $search);
		for ($user = 0; $user < $result["count"]; $user++) {		
			$ret[] = $result[$user][$ldap->getGroupAttr()][0];
		}
		return $ret;
	}

	function getLDAPCnx() {
		$auth = $this->getAuth();
		$ldap = new LDAP();

		$ldap->select($auth['db'], $auth['id']);
		$ds = ldap_connect($ldap->getAddr(), $ldap->getPort());
		ldap_set_option($ds, LDAP_OPT_PROTOCOL_VERSION, 3);
		if (!ldap_bind($ds, $ldap->getDN(), $ldap->getPassword()))
			return FALSE;
		return $ds;
	}

	function getACL($pass, $type) {
		if ($type == SQL) {
			$cnx = $this->getSQLCnx();
			if ($cnx) {
				$ids = $this->getSQLIDs($cnx);
			}
		}
		elseif ($type == LDAP_USR) {
			$cnx = $this->getLDAPCnx();
			if ($cnx) {
				$ids = $this->getLDAPUsers($cnx);
			}
		}
		elseif ($type == LDAP_GRP) {
			$cnx = $this->getLDAPCnx();
			if ($cnx) {
				$ids = $this->getLDAPGroups($cnx);
			}
		}
		if (is_array ($ids)) foreach ($ids as $id) {
			if ($type == SQL) {
				$u = new UserSQL();
				$u->select($id, $this->getAuth(), $cnx);
				if ($this->getPass($u->getID(), 0) == $pass)
					$ret[] = $u;
			}
			if ($type == LDAP_USR) {
				$u = new UserLDAP();
				$u->select($id, $this->getAuth(), $cnx);
				if ($this->getPass($u->getID(), 0) == $pass)
					$ret[] = $u;
			}
			if ($type == LDAP_GRP) {
				$g = new GroupLDAP();
				$g->select($id, $this->getAuth(), $cnx);
				if ($this->getPass($g->getID(), 1) == $pass)
					$ret[] = $g;
			}
			/* TODO : catch error when type is invalid */
		}
		return $ret;
	}

	function setSQLOK($ids) {
		$this->setACL($ids, TRUE, SQL);
	}

	function setSQLKO($ids) {
		$this->setACL($ids, FALSE, SQL);
	}

	function getSQLOK() {
		return $this->getACL(TRUE, SQL);
	}

	function getSQLKO() {
		return $this->getACL(FALSE, SQL);
	}

	function setLDAPUserOK($ids) {
		$this->setACL($ids, TRUE, LDAP_USR);
	}

	function setLDAPUserKO($ids) {
		$this->setACL($ids, FALSE, LDAP_USR);
	}

	function getLDAPUserOK() {
		return $this->getACL(TRUE, LDAP_USR);
	}

	function getLDAPUserKO() {
		return $this->getACL(FALSE, LDAP_USR);
	}

	function setLDAPGroupOK($ids) {
		$this->setACL($ids, TRUE, LDAP_GRP);
	}

	function setLDAPGroupKO($ids) {
		$this->setACL($ids, FALSE, LDAP_GRP);
	}

	function getLDAPGroupOK() {
		return $this->getACL(TRUE, LDAP_GRP);
	}

	function getLDAPGroupKO() {
		return $this->getACL(FALSE, LDAP_GRP);
	}
}
?>
