<?php
	
include_once "AbstractAction.php";
include_once "App.php";
	
class AppAction extends AbstractAction {
	
	function AppAction() {
	}
	
	function execute($mapping, $form, &$request, &$response) {
	
		parent::execute();

		$this->setForward('ko');
			
		$db = $this->getDS('MyDS');
		$db->setFetchMode(DB_FETCHMODE_ASSOC);
	
		if ($request->getParameter('default') && $request->getParameter('id')) {
			$id 	= $request->getParameter('default') ;
			$app	= $request->getParameter('id') ;
			$query = "UPDATE if SET default_app='".sqlite_escape_string ($app)."' WHERE id='".sqlite_escape_string ($id)."'";
			$result = $db->query("$query");
			if (DB::isError($result)) {
				print "Error: " . __FUNCTION__ . "() in " . __FILE__;
				$request->setAttribute('errors', $result);
				return $this->getForward($mapping);
			}
		}

		if (($del = $request->getParameter('del'))) {
			$query = "DELETE FROM app_filter WHERE id_app='".sqlite_escape_string($del)."'";
			$result = $db->query("$query");
			if (DB::isError($result)) {
				print "Error: " . __FUNCTION__ . "() in " . __FILE__;
				$request->setAttribute('errors', $result);
				return $this->getForward($mapping);
			}
		
			$query = "DELETE FROM app WHERE id='".sqlite_escape_string($del)."'";
			$result = $db->query("$query");
			if (DB::isError($result)) {
				print "Error: " . __FUNCTION__ . "() in " . __FILE__;
				$request->setAttribute('errors', $result);
				return $this->getForward($mapping);
			}	
		}

		if (($up = $request->getParameter('up'))) {
			$query = "UPDATE app SET up=1 WHERE id='".sqlite_escape_string($up)."'";
			$result = $db->query("$query");
			if (DB::isError($result)) {
				print "Error: " . __FUNCTION__ . "() in " . __FILE__;
				$request->setAttribute('errors', $result);
				return $this->getForward($mapping);
			}
		}

		if (($down = $request->getParameter('down'))) {
			$query = "UPDATE app SET up=0 WHERE id='".sqlite_escape_string($down)."'";
			$result = $db->query("$query");
			if (DB::isError($result)) {
				print "Error: " . __FUNCTION__ . "() in " . __FILE__;
				$request->setAttribute('errors', $result);
				return $this->getForward($mapping);
			}
		}

		$query = "SELECT id, type, id_auth FROM auth ORDER BY id";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			$request->setAttribute('errors', $result);
			return $this->getForward($mapping);	
		}
		$auth = array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			if ($row['type'] == 1) {
				$query = "SELECT name FROM ldap WHERE id='".$row['id_auth']."'";
				$ldap_result = $db->query("$query");
				if (DB::isError($sql_result)) {
					print "Error: " . __FUNCTION__ . "() in " . __FILE__;
	    				$request->setAttribute('errors', $ldap_result);
					return $this->getForward($mapping);
				}
				$ldap_row = $ldap_result->fetchRow(DB_FETCHMODE_ASSOC);
				$auth[$row['id']] = $ldap_row['name'];
			}
			if ($row['type'] == 2) {
				$query = "SELECT name FROM ca WHERE id='".$row['id_auth']."'";
				$sql_result = $db->query("$query");
				if (DB::isError($sql_result)) {
					print "Error: " . __FUNCTION__ . "() in " . __FILE__;
		    			$request->setAttribute('errors', $sql_result);
					return $this->getForward($mapping);
				}
				$ca_row = $sql_result->fetchRow(DB_FETCHMODE_ASSOC);
				$auth[$row['id']] = $ca_row['name'];
			}
			if ($row['type'] == 3) {
				$query = "SELECT name FROM sql WHERE id='".$row['id_auth']."'";
				$sql_result = $db->query("$query");
				if (DB::isError($sql_result)) {
					print "Error: " . __FUNCTION__ . "() in " . __FILE__;
	    				$request->setAttribute('errors', $sql_result);
					return $this->getForward($mapping);
				}
				$sql_row = $sql_result->fetchRow(DB_FETCHMODE_ASSOC);
				$auth[$row['id']] = $sql_row['name'];
			}
		}
	
		$query = "SELECT id, name FROM if ORDER BY id";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			$request->setAttribute('errors', $result);
			return $this->getForward($mapping);
		}
		$iface=array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			$iface[$row['id']] = $row['name'];
		}
		
		$query = "SELECT id, name FROM log ORDER BY name";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			$request->setAttribute('errors', $result);
			return $this->getForward($mapping);
		}
		$log=array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			$log[$row['id']] = $row['name'];
		}


		$query = "SELECT * FROM app ORDER BY name";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			$request->setAttribute('errors', $result);
			return $this->getForward($mapping);
		}

		$request->setAttribute('app', $result);
		$request->setAttribute('auth', $auth);
		$request->setAttribute('iface', $iface);
		$request->setAttribute('log', $log);
		$this->setForward('ok');

		return $this->getForward($mapping);
	}
}

?>
