<?

include_once "ACL.php";

define('HTPASSWD', 4);
	
class Htpasswd {
	
	function setID($id) {
		$this->id = $id;
	}
	
	function getID() {
		return $this->id;
	}
	
	function getName() {
		return $this->name;
	}
	
	function setName($name) {
		$this->name = $name;
	}
	
	function getFile() {
		return $this->file;
	}
	
	function setFile($file) {
		$this->file = $file;
	}
	
	function getACL($db) {
		$acl = new ACL();
		$acl->setAuth($db, $this->getID());
		return $acl;
	}

	function setIsACL($is_acl) {
		$this->is_acl = $is_acl;
	}

	function getIsACL() {
		return $this->is_acl;
	}

	function update($db) {
		global $i18n;

		$query	= "SELECT * FROM htpasswd WHERE name='". sqlite_escape_string($this->getName()) ."' AND id!='".sqlite_escape_string($this->getID())."'";
		$result = $db->query($query);
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		if ($result->fetchRow(DB_FETCHMODE_ASSOC)) return $this->getName() . " ". $i18n["already_exists"];
		$query = "UPDATE htpasswd SET ".
				 "name='". 		sqlite_escape_string($this->getName()) ."'," .
				 "file='". 		sqlite_escape_string($this->getFile()) ."' ".
				 "WHERE id='".		sqlite_escape_string($this->getID())."'
		";
		$result = $db->query($query);
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		return FALSE;
	}
	
	function select($db, $id) {
		$query = "SELECT * FROM htpasswd WHERE id='".sqlite_escape_string($id)."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
		$this->setName		(stripslashes ($row['name']));
		$this->setFile		(stripslashes ($row['file']));
		$this->setID		(stripslashes ($id));
	}
	
	function delete($db) {
		global $i18n;
		$id = $id = $this->getID();

		$query = "SELECT id FROM auth WHERE id_auth='".sqlite_escape_string($id)."' AND type='".HTPASSWD."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		if ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			$query = "SELECT id FROM app WHERE auth='".$row['id']."'";
			$result = $db->query("$query");
			if (DB::isError($result)) {
				print "Error: " . __FUNCTION__ . "() in " . __FILE__;
				print_r($result);
				return TRUE;
			}
			if ($result->fetchRow(DB_FETCHMODE_ASSOC)) return $i18n["auth_used"];
		}
		$query = "DELETE FROM htpasswd WHERE id='".sqlite_escape_string($id)."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		$query = "DELETE FROM auth WHERE id_auth='".sqlite_escape_string($id)."' AND type='".HTPASSWD."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		return FALSE;
	}
	
	function insert($db) {
		global $i18n;
	
		$query = "SELECT * FROM htpasswd WHERE name='". sqlite_escape_string($this->getName()) ."'";
		$result = $db->query($query);
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		if ($result->fetchRow(DB_FETCHMODE_ASSOC))
			return $this->getName() . " " . $i18n["already_exists"];

		$query = "INSERT INTO htpasswd (name, file) VALUES('".
				 sqlite_escape_string($this->getName()). "', '".
				 sqlite_escape_string($this->getFile()) ."')
		";
		$result = $db->query($query);
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}

		$query = "SELECT * FROM htpasswd WHERE name='". sqlite_escape_string($this->getName()) ."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
		$query = "INSERT INTO auth (type, id_auth) VALUES('".HTPASSWD."','".$row['id']."')";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		return FALSE;
	}
}
	
	
?>
