<?
	
include_once "App.php";
include_once "Filter.php";
include_once "Logs.php";
	
class Intf {
	
	function Intf() {
	
	}
	
	function setID($id) {
		$this->id = $id;
	}
	
	function getID() {
		return $this->id;
	}
	
	function getName() {
		return $this->name;
	}
	
	function setName($name) {
		$this->name = $name;
	}
	
	function setIP($ip) {
		$this->ip = $ip;
	}
	
	function getIP() {
		return $this->ip;
	}
	
	function setPort($port) {
		$this->port = $port;
	}
	
	function getPort() {
		return $this->port;
	}
	
	function setEngine($engine) {
		$this->engine = $engine;
	}
	
	function getEngine() {
		return $this->engine;
	}
	
	function setCrt($crt) {
		$this->crt = $crt;
	}
	
	function getCrt() {
		return $this->crt;
	}
	
	function setChainFile($chainfile) {
		$this->chainfile = $chainfile;
	}
	
	function getChainFile() {
		return $this->chainfile;
	}
	
	function setKey($key) {
		$this->key = $key;
	}
	
	function getKey() {
		return $this->key;
	}
	
	function getIntfDir() {
		global $intf_dir;
		return $intf_dir;
	}

	function getApacheDir() {
		global $httpd_root;
		return $httpd_root;
	}

	function getApacheModules() {
		global $apache_modules;
		return $apache_modules;
	}

	function getProxyAddress() {
		global $proxy_address;
		return $proxy_address;
	}

	function getProxyPort() {
		global $proxy_port;
		return $proxy_port;
	}

	function getDbiUri() {
		global $dbi_uri;
		return $dbi_uri;
	}

	function getLibDir() {
		global $lib_dir;
		return $lib_dir;
	}
	
	function getSSLVerifyClient() {
		return $this->ca_require;
	}
	
	function setSSLVerifyClient($type) {
		$this->ca_require = $type;
	}
	
	function getSSLConstraint() {
		return $this->ssl_constraint;
	}
	
	function setSSLContraint($ssl_constraint) {
		$this->ssl_constraint = $ssl_constraint;
	}
	
	function getLog() {
		return $this->log;
	}
	
	function setLog($log) {
		$this->log = $log;
	}
	
	function getApps($db) {
		$ret = array();
		$query = "SELECT id FROM app WHERE if = '".$this->getID()."' ORDER BY id";
		$result = $db->query("$query");
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			$app = new App();
			$app->select($db, $row['id']);
			array_push($ret, $app);
		}
		return $ret;
	}

	function getFile($extension) {
		$id = $this->getID();
		if ($id) {
			$filename = $this->getIntfDir()."/".$id . $extension;
			if (file_exists($filename) && is_file($filename) && is_readable($filename)) {
				$fp = fopen($filename,"r");
				$ret = "";
				while ($fp && !feof ($fp)) $ret .= fgets($fp, 512);
				fclose($fp);
				return $ret;
			}
		}
		return NULL;
	}
	
	function buildFile($extension, $content) {
		$id = $this->getID();
		if ($id) {
			$fp = fopen($this->getIntfDir()."/".$id. $extension,"w+");
			fputs($fp,$content);
			fclose($fp);
		}
	}
	
	function getConfFile() {
		return $this->getFile(".conf");
	}
	
	function getCrtFile() {
		return $this->getFile(".crt");
	}
	
	function getCAFile() {
		return $this->getFile(".ca");
	}
	
	function getCAChainFile() {
		return $this->getFile(".chain");
	}
	
	function getKeyFile() {
		return $this->getFile(".key");
	}
	
	function buildConf($db) {
		$apps		= $this->getApps($db);
		$id		= $this->getID();
		$port		= $this->getPort();
		$logs		= $this->getLog();
		$ip		= $this->getIP();
		$intf_dir	= $this->getIntfDir();
		$httpd_root	= $this->getApacheDir();
		$lib_dir	= $this->getLibDir();
		$apache_modules	= $this->getApacheModules();
		$proxy_address	= $this->getProxyAddress();
		$proxy_port	= $this->getProxyPort();
		$dbi_uri	= $this->getDbiUri();

		if ($logs) {
                        $log = new Logs();
                        $log -> select ($db,$logs);
                        $custom_log = eregi_replace("\r\n","\n",$log->getRules());
                        $custom_log.="\n";
                        $custom_log = eregi_replace("%NAME%",$ip,$custom_log);
			$logs="";
                }

		

		$auth_proto = "http";
		if ($this->getKey() && $this->getCrt()) {
		  $auth_proto .= "s";
		}

		/* CA Authentication */
		$query = "
			SELECT auth.id, auth.id_auth 
			FROM auth, app 
			WHERE auth.id	= app.auth
			AND auth.type	= '2'
			AND app.if	= '$id'
		";
		$result = $db->query("$query");
		while ($row = $result->fetchrow(DB_FETCHMODE_ASSOC)) {
			$query = "SELECT require, crt, ssl_constraint FROM ca WHERE id='".$row['auth.id_auth']."'";
			$ca_result = $db->query($query);
			$ca_row = $ca_result->fetchrow(DB_FETCHMODE_ASSOC);
			$auth[$row['auth.id']]['require']	= $ca_row['require'];
			$auth[$row['auth.id']]['ssl_constraint']= stripslashes ($ca_row['ssl_constraint']);
			$auth[$row['auth.id']]['ca']		= $ca_row['crt'];
			$this->buildCA($row['auth.id'], $ca_row['crt']);
		}

		if ($this->getKey() && $this->getCrt()) {
			$perlvar="PerlSetVar is_ssl TRUE \n";
		}
		else {
			$perlvar="PerlSetVar is_ssl FALSE \n";
		}
		$perlvar .= "\tPerlSetVar if_id ". $this->getID()."\n";


$conf = 
<<<EOF
ServerRoot /home

ServerTokens Prod
ServerSignature Off

Timeout 300
KeepAlive On
MaxKeepAliveRequests 100
KeepAliveTimeout 15

StartServers            5
MinSpareServers         5
MaxSpareServers         10
MaxClients              150
MaxRequestsPerChild     0

PidFile $intf_dir/$id.pid
	
user apache
group apache

$apache_modules

AddDefaultCharset off

#PerlModule Apache2

<Perl>

	use Vulture qw(&init);

	init("$auth_proto", "$proxy_address", "$proxy_port", "$dbi_uri");

</Perl>

#PerlModule Vulture;

Listen $ip:$port
NameVirtualHost $ip:$port

<IfModule mod_mime.c>	
TypesConfig $httpd_root/conf/mime.types
</IfModule>

$custom_log

$perlvar

SetHandler perl-script                                                                                                                                  
PerlResponseHandler Vulture::ResponseHandler

EOF;

	
		if ($this->getKey() && $this->getCrt()) {
			$conf.="SSLSessionCache dbm:$intf_dir/ssl_session_$id.cache \n";
			$conf.="SSLRandomSeed startup builtin \n";
			$conf.="SSLRandomSeed connect builtin \n";
			if ($this->getEngine()) $conf.="SSLCryptoDevice ".$this->getEngine();
			$conf.="\n\n";
		}
	
		foreach ($apps as $app) {
			$servername = $app->getName();
	
			if ($auth[$app->getAuth()]['ca']) {
				$ca_require	= $auth[$app->getAuth()]['require'];
				$ssl_constraint	= $auth[$app->getAuth()]['ssl_constraint'];
				$ca_file	= "SSLCACertificateFile	" . $intf_dir . "/" . $app->getAuth() . ".ca\n";
				$depth		= "SSLVerifyDepth	2";
			}
			else {
				$ca_file 	= "\n";
				$ssl_constraint = "\n";
				$ca_require 	= "none";
				$depth		= "";
			}

			$filters	= $app->getFilter();
			$logs		= $app->getLog();
			if ($logs) {
				$log = new Logs();
				$log -> select ($db,$logs);
				$custom_log = eregi_replace("\n","\n\t",$log->getRules());
				$custom_log.="\n";
				$custom_log = eregi_replace("%NAME%",$servername,$custom_log);
			}
			$filter_config	= eregi_replace("\r\n","\n",$app->getFilterConfig());
			$access_config	= eregi_replace("\r\n","\n",$app->getAccessConfig());

			$security_rules="";
			if (is_array ($filters) && count ($filters)!=0 || $filter_config!="") {

				$security_rules	= "SecFilterEngine On \n";
				$security_rules.= "\tSecAuditLog /var/log/Vulture-$servername-security_log \n";
				$security_rules.= $filter_config;

				foreach ($filters as $id_filter) {
					$filter=new Filter();
					$filter->select ($db,$id_filter);
					$security_rules.=$filter->getRules();
					$security_rules.="\n";
				}
			}

$conf .= 
<<<EOF

<VirtualHost $ip:$port>
	ServerName $servername
	$custom_log
	
EOF;
			if ($this->getKey() && $this->getCrt()) {
				$chainfile="SSLCertificateChainFile $intf_dir/$id.chain";
				$perlvar="PerlSetVar is_ssl TRUE \n";
			}
			else {
				$chainfile="";
				$perlvar="PerlSetVar is_ssl FALSE \n";
			}
			$perlvar .= "\tPerlSetVar if_id ". $this->getID()."\n";

			if ($this->getKey() && $this->getCrt()) {
$conf .= 
<<<EOF

	SSLEngine 		On
	$sslengine
	SSLCertificateKeyFile	$intf_dir/$id.key
	SSLCertificateFile	$intf_dir/$id.crt 
	$chainfile
	$ca_file
	
	SSLOptions 		+StdEnvVars
	SSLVerifyClient		$ca_require
	$depth



EOF;
			}
			$conf .= 
<<<EOF
	
	SSLProxyEngine On
	
	SetHandler perl-script
	$perlvar
        PerlTransHandler Vulture::TransHandler
	PerlResponseHandler Vulture::ResponseHandler

	ProxyRequests Off
	ProxyVia Off

	$security_rules

	<Proxy *>
	SetHandler perl-script
	$ssl_constraint
	$access_config	
	</Proxy>
</VirtualHost>
	
EOF;
		}
	
		return $conf;
	}
	
	function setNeedRestart($flag) {
		$this->need_restart = $flag;
	}
	
	function getNeedRestart() {
		return $this->need_restart;
	}
	
	function buildCA($id,$ca) {
		if ($id) {
			$fp = fopen($this->getIntfDir()."/".$id. ".ca","w+");
			fputs($fp,$ca);
			fclose($fp);
		}
	}
	
	function commit($db) {
		$id = $this->getID();
		if ($id) {
			if ($err = $this->buildFile(".conf", $this->buildConf($db))) return $err;
			if ($crt = $this->getCrt())
				if ($err = $this->buildFile(".crt",  $crt)) return $err;
	
			if ($key = $this->getKey())
				if ($err = $this->buildFile(".key",  $key)) return $err;
			
			if ($chainfile = $this->getChainFile())
				if ($err = $this->buildFile(".chain", $chainfile)) return $err;
		}
	}
	
	function start() {
		global $httpd;
	
		$id = $this->getID();
		if ($id) {
			$conf = $this->getIntfDir()."/".$id.".conf";
			$result = shell_exec("$httpd -f $conf -k start 2>&1");
		}
		sleep(3);
		return $result;
	}
	
	function stop() {
		global $httpd;
	
		$id = $this->getID();
		if ($id) {
			$conf = $this->getIntfDir()."/".$id.".conf";
			$result = shell_exec("$httpd -f $conf -k stop 2>&1");
		}
		sleep(3);
		return $result;
	}
	
	function restart($db) {
		$ret = $this->commit($db);
		$ret .= $this->stop();
		$ret .= $this->start();
		$ret = str_replace('\n',"<br>", $ret);
		return $ret;
	}
	
	function status() {
		$id = $this->getID();
		if ($id) {
			$filename = $this->getIntfDir()."/".$id.".pid";
			if (file_exists($filename) && is_file($filename) && is_readable($filename)) {
				$fp = fopen($filename,"r");
				while ($fp && !feof ($fp)) $ret.= fgets($fp, 512);
				fclose($fp);
				return $ret;
			}
		}
	}
	
	function delete($db) {
		
		global $i18n;
		$id = $this->getID();

		$query = "SELECT if FROM app WHERE if='".sqlite_escape_string($id)."'";
                $result = $db->query("$query");
                if (DB::isError($result)) {
                        print "Error: " . __FUNCTION__ . "() in " . __FILE__;
                        print_r($result);
                        return TRUE;
                }
                if ($result->fetchRow(DB_FETCHMODE_ASSOC)) return $i18n["if_used"];
		
		$this->stop($db);
		if ($id && !$this->status()) { 
			$query = "DELETE FROM if WHERE id='".sqlite_escape_string($id)."'";
			$result = $db->query("$query");
			if (DB::isError($result)) {
				print "Error: " . __FUNCTION__ . "() in " . __FILE__;
				print_r($result);
				return TRUE;
			}
		}
		return FALSE;
	}
	
	function update($db) {

		global $i18n;
	
		$query = "SELECT * FROM if WHERE name='". sqlite_escape_string($this->getName()) ."' AND id!='".sqlite_escape_string($this->getID())."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		} 
		if ($result->fetchRow(DB_FETCHMODE_ASSOC)) return $this->getName() . " " . $i18n["already_exists"];
	
		
		$query = "UPDATE if SET ".
				 "name='". 	sqlite_escape_string($this->getName()) . "', ".
				 "port='". 	sqlite_escape_string($this->getPort()) . "', ".
				 "log='". 	sqlite_escape_string($this->getLog()) . "', ".
				 "ip='". 	sqlite_escape_string($this->getIP()) . "', ".
				 "engine='". 	sqlite_escape_string($this->getEngine()) . "', ".
				 "crt='". 	sqlite_escape_string($this->getCrt()) . "', ".
				 "chainfile='". sqlite_escape_string($this->getChainFile()) . "', ".
				 "key='". 	sqlite_escape_string($this->getKey()) . "' ".
				 "WHERE id='".	sqlite_escape_string($this->getID())."'
		";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		return FALSE;
	}
	
	function select($db, $id) {
		$query = "SELECT * FROM if WHERE id='".sqlite_escape_string($id)."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
	
		$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
	
		$this->setName		(stripslashes ($row['name']));
		$this->setIP		(stripslashes ($row['ip']));
		$this->setPort		(stripslashes ($row['port']));
		$this->setLog		(stripslashes ($row['log']));
		$this->setEngine	(stripslashes ($row['engine']));
		$this->setKey		(stripslashes ($row['key']));
		$this->setCrt		(stripslashes ($row['crt']));
		$this->setChainFile	(stripslashes ($row['chainfile']));
		$this->setID		($id);
		return FALSE;
	}
	
	function insert($db) {
		$query = "INSERT INTO if (ip, chainfile, crt, key, port, log, engine, name) VALUES(".
				 "'" . sqlite_escape_string($this->getIP()). "', ".
				 "'" . sqlite_escape_string($this->getChainFile()). "', ".
				 "'" . sqlite_escape_string($this->getCrt()). "', ".
				 "'" . sqlite_escape_string($this->getKey()). "', ".
				 "'" . sqlite_escape_string($this->getPort()). "', ".
				 "'" . sqlite_escape_string($this->getLog()). "', ".
				 "'" . sqlite_escape_string($this->getEngine()). "', ".
				 "'" . sqlite_escape_string($this->getName()). "')
		";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		return FALSE;
	}

}
	
?>
