<?
	
class LDAP {
	
	function LDAP() {
	
	}
	
	function setID($id) {
		$this->id = $id;
	}
	function getID() {
		return $this->id;
	}
	
	function setName($name) {
		$this->name = $name;
	}
	function getName() {
		return $this->name;
	}

	function setAddr ($ldap_addr) {
		$this->ldap_addr = $ldap_addr;
	}
	function getAddr () {
		return $this->ldap_addr;
	}

	function setPort ($ldap_port) {
		$this->ldap_port = $ldap_port;
	}
	function getPort () {
		return $this->ldap_port;
	}

	function setDN ($ldap_dn) {
		$this->ldap_dn = $ldap_dn;
	}
	function getDN () {
		return $this->ldap_dn;
	}

	function setPassword ($ldap_password) {
		$this->ldap_password = $ldap_password;
	}
	function getPassword () {
		return $this->ldap_password;
	}

	function setBaseDN ($ldap_base_dn) {
		$this->ldap_base_dn = $ldap_base_dn;
	}
	function getBaseDN () {
		return $this->ldap_base_dn;
	}

	function setUserAttr ($ldap_user_attr) {
		$this->ldap_user_attr = $ldap_user_attr;
	}
	function getUserAttr () {
		return $this->ldap_user_attr;
	}

	function setGroupAttr ($ldap_group_attr) {
		$this->ldap_group_attr = $ldap_group_attr;
	}
	function getGroupAttr () {
		return $this->ldap_group_attr;
	}

	function setGroupMember ($ldap_group_member) {
		$this->ldap_group_member = $ldap_group_member;
	}
	function getGroupMember () {
		return $this->ldap_group_member;
	}

	function setGroupIsDN ($ldap_group_is_dn) {
		$this->ldap_group_is_dn = $ldap_group_is_dn;
	}
	function getGroupIsDN () {
		return $this->ldap_group_is_dn;
	}

	function getACL($db) {
		$acl = new ACL();
		$acl->setAuth($db, $this->getID());
		return $acl;
	}

	function setIsACL($is_acl) {
		$this->is_acl = $is_acl;
	}

	function getIsACL() {
		return $this->is_acl;
	}

	function delete($db) {
		global $i18n;

		$id = $this->getID();

		$query = "SELECT id FROM auth WHERE id_auth='".sqlite_escape_string($id)."' AND type='1'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		if ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			$query = "SELECT id FROM app WHERE auth='".$row['id']."'";
			$result = $db->query("$query");
			if (DB::isError($result)) {
				print "Error: " . __FUNCTION__ . "() in " . __FILE__;
				print_r($result);
				return TRUE;
			}
			if ($result->fetchRow(DB_FETCHMODE_ASSOC)) return $i18n["auth_used"];
			
		}
		$query = "DELETE FROM ldap WHERE id='".sqlite_escape_string($id)."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		$query = "DELETE FROM auth WHERE id_auth='".sqlite_escape_string($id)."' AND type='1'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		return FALSE;
	}
	
	function update($db) {
		global $i18n;
		$query = "SELECT * FROM ldap WHERE name='". sqlite_escape_string($this->getName()) ."' AND id!='".sqlite_escape_string($this->getID())."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		} 
		if ($result->fetchRow(DB_FETCHMODE_ASSOC)) return $this->getName() . " " . $i18n["already_exists"];
		$query = "
			UPDATE ldap
			SET name='". 		sqlite_escape_string($this->getName()) . "', 
		        is_acl='".		sqlite_escape_string($this->getIsACL()) ."',
			ldap_addr='". 		sqlite_escape_string($this->getAddr()) . "', 
			ldap_port='". 		sqlite_escape_string($this->getPort()) . "', 
			ldap_dn='". 		sqlite_escape_string($this->getDN()) . "', 
			ldap_password='". 	sqlite_escape_string($this->getPassword()) . "', 
			ldap_base_dn='". 	sqlite_escape_string($this->getBaseDN()) . "', 
			ldap_user_attr='". 	sqlite_escape_string($this->getUserAttr()) . "', 
			ldap_group_attr='".  	sqlite_escape_string($this->getGroupAttr()) . "',
			ldap_group_is_dn='".  	sqlite_escape_string($this->getGroupIsDN()) . "',
			ldap_group_member='".  	sqlite_escape_string($this->getGroupMember()) . "' ".
			"WHERE id='".		sqlite_escape_string($this->getID())."'
		";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		return FALSE;
	}

	function select($db, $id) {
		$query = "SELECT * FROM ldap WHERE id='".sqlite_escape_string($id)."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
		$this->setName		(stripslashes ($row['name']));
		$this->setAddr		(stripslashes ($row['ldap_addr']));
		$this->setPort		(stripslashes ($row['ldap_port']));
		$this->setDN		(stripslashes ($row['ldap_dn']));
		$this->setPassword	(stripslashes ($row['ldap_password']));
		$this->setBaseDN	(stripslashes ($row['ldap_base_dn']));
		$this->setUserAttr	(stripslashes ($row['ldap_user_attr']));
		$this->setGroupAttr	(stripslashes ($row['ldap_group_attr']));
		$this->setGroupMember	(stripslashes ($row['ldap_group_member']));
		$this->setGroupIsDN	(stripslashes ($row['ldap_group_is_dn']));
		$this->setIsACL		(stripslashes ($row['is_acl']));
		$this->setID($id);
	}
	
	function insert($db) {
		global $i18n;

		$query = "SELECT * FROM ldap WHERE name='".sqlite_escape_string($this->getName())."'";
		$result = $db->query($query);
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		} 
	
		if ($result->fetchRow(DB_FETCHMODE_ASSOC)) return $this->getName() . " " . $i18n["already_exists"];
		
		$query = "
			INSERT INTO ldap (name, is_acl, ldap_addr, ldap_port, ldap_dn, ldap_password, ldap_base_dn, ldap_user_attr, ldap_group_attr, ldap_group_is_dn, ldap_group_member)
			VALUES ('".sqlite_escape_string($this->getName())."',
				'".sqlite_escape_string($this->getIsACL())."',
				'".sqlite_escape_string($this->getAddr())."',
				'".sqlite_escape_string($this->getPort())."',
				'".sqlite_escape_string($this->getDN())."',
				'".sqlite_escape_string($this->getPassword())."',
				'".sqlite_escape_string($this->getBaseDN())."',
				'".sqlite_escape_string($this->getUserAttr())."',
				'".sqlite_escape_string($this->getGroupAttr())."',
				'".sqlite_escape_string($this->getGroupIsDN())."',
				'".sqlite_escape_string($this->getGroupMember())."'
			)
		";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		$query = "SELECT * FROM ldap WHERE name='". sqlite_escape_string($this->getName()) ."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
		$row['id'];
		$query = "INSERT INTO auth (type, id_auth) VALUES('1','".$row['id']."')";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		return FALSE;		
	}
}
	
	
?>
