<?php
/*
* $Header: LogonAction.php
* $Revision:
* $Date: 12.August.2003
*
* ====================================================================
*
* License:	GNU General Public License
*
* Copyright (c) 2002, 2003 John C.Wildenauer.  All rights reserved.
* Note: Original work copyright to respective authors
*
* This file is part of php.MVC.
*
* php.MVC is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version. 
* 
* php.MVC is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details. 
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, 
* USA.
*/


/**
* Logon handling.<br>
*
* @author John C Wildenauer (php.MVC port)
* @version
* @public
*/
class List extends Action {

	// ----- Instance Variables --------------------------------------------- //

	/**
	* The <code>Log</code> instance for this application.
	* @private
	* @type Log
	*/
	var $log = NULL;


	// ----- Constructor ---------------------------------------------------- //

	function List() {
		
		$this->log	= new Log();
		$this->log->setLog('isDebugEnabled'	, False);
		$this->log->setLog('isTraceEnabled'	, False);

	}


	// ----- Public Methods ------------------------------------------------- //

	/**
	* Process the specified HTTP request, and create the corresponding HTTP
	* response (or forward to another web component that will create it).
	* Return an <code>ActionForward</code> instance describing where and how
	* control should be forwarded, or <code>null</code> if the response has
	* already been completed.
	*
	* @param mapping ActionConfig, The ActionConfig (mapping) used to select 
	*   this instance
	* @param form ActionForm, The optional ActionForm bean for this request (if any)
	* @param request HttpServletRequest, The HTTP request we are processing
	* @param response HttpServletResponse, The HTTP response we are creating
	*
	* @public
	* @returns ActionForward
	*/
	function execute($mapping, $form, &$request, &$response) {
		return $mapping->findForwardConfig('Welcome');
	}
}
?>