<?

class OpenSSL {

  function setFile($file, $pass = '') {
    $this->setDSA(`openssl dsa -in $file 2>/dev/null`);
    $this->setRSA(`openssl rsa -in $file 2>/dev/null`);
    $this->setPEM(`openssl x509 -in $file 2>/dev/null`);
    $this->setP12(`openssl pkcs12 -passin pass:$pass -in $file -nodes 2>/dev/null`);
  }

  function setPEM($pem) {
    if ($pem) {
      $this->setCrt($pem);
      $this->setKey($pem);
    }
  }

  function setP12($p12) {
    if ($p12) {
      $this->setCrt($p12);
      $this->setKey($p12);
    }
  }

  function setRSA($rsa) {
    eregi("-----BEGIN RSA PRIVATE KEY-----(.*)-----END RSA PRIVATE KEY-----", $rsa, $match);
    if ($match[0]) {
      $this->key = $match[0];
    }
  }

  function setDSA($dsa) {
    eregi("-----BEGIN DSA PRIVATE KEY-----(.*)-----END DSA PRIVATE KEY-----", $dsa, $match);
    if ($match[0]) {
      $this->key = $match[0];
    }
  }

  function setCrt($crt) {
    $this->crt = '';
    eregi("-----BEGIN CERTIFICATE-----(.*)-----END CERTIFICATE-----", $crt, $match);
    if ($match[0]) {
      $this->crt = $match[0];
    }
  }

  function setChainFile ($chainfile) {
	$this->chainfile = $chainfile;
  }

  function getChainFile () {
	return $this->chainfile;
  }

  function setEngine ($engine) {
	$this->engine = $engine;
  }

  function getEngine () {
	return $this->engine;
  }

  function setKey($key) {
    $this->key = '';
    $this->setRSA($key);
    $this->setDSA($key);
  }

  function getCrt() {    
    return $this->crt;
  }

  function getKey() {
    return $this->key;
  }
}


?>
