<?

include_once "ACL.php";
	
class SQL {
	
	function SQL() {
	
	}
	
	function setID($id) {
		$this->id = $id;
	}
	
	function getID() {
		return $this->id;
	}
	
	function getName() {
		return $this->name;
	}
	
	function setName($name) {
		$this->name = $name;
	}
	
	function getTableName() {
		return $this->table_name;
	}
	
	function setTableName($table_name) {
		$this->table_name = $table_name;
	}
	
	function getLoginColumn() {
		return $this->login_column;
	}
	
	function setLoginColumn($login_column) {
		$this->login_column = $login_column;
	}
	
	function getDbName() {
		if (ereg("dbi:[[:alnum:]]*:dbname=([[:alnum:]/_]*)",$this->getUri(), $regs)) return $regs[1];
		
	}
	
	function setDbName($db_name) {
		$this->setUri("dbi:". $this->getDbType() .":dbname=". $db_name);
	}

	function getDbHost() {
		if (ereg(".*:host=([[:alnum:]\-\._]*)",$this->getUri(), $regs)) return $regs[1];
	}

	function getDbPort() {
		if (ereg(".*:port=([0-9]*)",$this->getUri(), $regs)) return $regs[1];
	}

	function setDbHost($host) {
		if ($this->getDbType() == "Pg") {
			list($host, $port) = split(":", $host);
			if ($port)
				$host .= ":port=".$port;
			$this->setUri("dbi:". $this->getDbType() .":dbname=". $this->getDbName() .":host=". $host);
		}
	}
	
	function getDbType() {
		if (ereg("dbi:([[:alnum:]]*):dbname=[[:alnum:]]*",$this->getUri(), $regs)) return $regs[1];
	}
	
	function setDbType($db_type) {
		$this->setUri("dbi:". $db_type .":dbname=". $this->getDbName());
	}
	
	function getUri() {
		return $this->uri;
	}
	
	function setUri($uri) {
		$this->uri = $uri;
	}
	
	function getDbUser() {
		return $this->db_user;
	}
	
	function setDbUser($db_user) {
		$this->db_user = $db_user;
	}
	
	function getDbPassword() {
		return $this->db_password;
	}
	
	function setDbPassword($db_password) {
		$this->db_password = $db_password;
	}

	function setPasswordColumn($password_column) {
		$this->password_column = $password_column;
	}
	
	function getPasswordColumn() {
		return $this->password_column;
	}
	
	function getACL($db) {
		$acl = new ACL();
		$acl->setAuth($db, $this->getID());
		return $acl;
	}

	function setIsACL($is_acl) {
		$this->is_acl = $is_acl;
	}

	function getIsACL() {
		return $this->is_acl;
	}

	function update($db) {
		global $i18n;

		$query	= "SELECT * FROM sql WHERE name='". sqlite_escape_string($this->getName()) ."' AND id!='".sqlite_escape_string($this->getID())."'";
		$result = $db->query($query);
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		} 
		if ($result->fetchRow(DB_FETCHMODE_ASSOC)) return $this->getName() . " ". $i18n["already_exists"];
		$query = "UPDATE sql SET ".
				 "name='". 		sqlite_escape_string($this->getName()) ."'," .
				 "uri='". 		sqlite_escape_string($this->getUri()) ."',".
				 "db_user='". 		sqlite_escape_string($this->getDbUser()) ."',".
				 "db_pass='". 		sqlite_escape_string($this->getDbPassword()) ."',".
				 "table_name='".	sqlite_escape_string($this->getTableName()) ."',".
				 "is_acl='".		sqlite_escape_string($this->getIsACL()) ."',".
				 "login_column='".	sqlite_escape_string($this->getLoginColumn()) ."',".
				 "password_column='". 	sqlite_escape_string($this->getPasswordColumn()) ."' ".
				 "WHERE id='".		sqlite_escape_string($this->getID())."'
		";
		$result = $db->query($query);
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		return FALSE;
	}
	
	function select($db, $id) {
		$query = "SELECT * FROM sql WHERE id='".sqlite_escape_string($id)."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
		$this->setName		(stripslashes ($row['name']));
		$this->setUri		(stripslashes ($row['uri']));
		$this->setTableName	(stripslashes ($row['table_name']));
		$this->setLoginColumn	(stripslashes ($row['login_column']));
		$this->setPasswordColumn(stripslashes ($row['password_column']));
		$this->setDbUser	(stripslashes ($row['db_user']));
		$this->setDbPassword	(stripslashes ($row['db_pass']));
		$this->setIsACL		(stripslashes ($row['is_acl']));
		$this->setID		(stripslashes ($id));
	}
	
	function delete($db) {
		global $i18n;
		$id = $id = $this->getID();

		$query = "SELECT id FROM auth WHERE id_auth='".sqlite_escape_string($id)."' AND type='3'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		if ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			$query = "SELECT id FROM app WHERE auth='".$row['id']."'";
			$result = $db->query("$query");
			if (DB::isError($result)) {
				print "Error: " . __FUNCTION__ . "() in " . __FILE__;
				print_r($result);
				return TRUE;
			}
			if ($result->fetchRow(DB_FETCHMODE_ASSOC)) return $i18n["auth_used"];
		}
		$query = "DELETE FROM sql WHERE id='".sqlite_escape_string($id)."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		$query = "DELETE FROM auth WHERE id_auth='".sqlite_escape_string($id)."' AND type='3'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		return FALSE;
	}
	
	function insert($db) {
		global $i18n;
	
		$query = "SELECT * FROM sql WHERE name='". sqlite_escape_string($this->getName()) ."'";
		$result = $db->query($query);
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		if ($result->fetchRow(DB_FETCHMODE_ASSOC)) return $this->getName() . " " . $i18n["already_exists"];
	
		
		$query = "INSERT INTO sql (name, uri, db_user, db_pass, login_column, password_column, is_acl, table_name) VALUES('".
				 sqlite_escape_string($this->getName()). "', '".
				 sqlite_escape_string($this->getUri()) ."', '".
				 sqlite_escape_string($this->getDbUser()) ."', '".
				 sqlite_escape_string($this->getDbPassword()) ."', '".
				 sqlite_escape_string($this->getLoginColumn()) ."', '".
				 sqlite_escape_string($this->getPasswordColumn()) ."', '".
				 sqlite_escape_string($this->getIsACL()) ."', '".
				 sqlite_escape_string($this->getTableName()) ."')
		";
		$result = $db->query($query);
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}

		$query = "SELECT * FROM sql WHERE name='". sqlite_escape_string($this->getName()) ."'";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
		$query = "INSERT INTO auth (type, id_auth) VALUES('3','".$row['id']."')";
		$result = $db->query("$query");
		if (DB::isError($result)) {
			print "Error: " . __FUNCTION__ . "() in " . __FILE__;
			print_r($result);
			return TRUE;
		}
		return FALSE;
	}
}
	
	
?>
