<?php
	
include_once "AbstractAction.php";
include_once "Utils.php";
include_once "App.php";
	
class addApp extends AbstractAction {
	
	function addApp() {
		parent::AbstractAction();
	}
	
	function execute($mapping, $form, &$request, &$response) {

		global $i18n;
		parent::execute();
	
		$this->setForward('ko');
		$db  = $this->getDS('MyDS');
		
		if ($form->getSubmit() && !$form->getErrors()) {
			$app = new App();

			$app->setName		($form->getAppName());
			$app->setAlias		($form->getAppAlias());
			$app->setUrl		($form->getAppUrl());
			$app->setAuth		($form->getAppAuth());
			$app->setFilter		($form->getAppFilter());
			$app->setFilterConfig	($form->getAppFilterConfig());
			$app->setAccessConfig	($form->getAppAccessConfig());
			$app->setIface		($form->getAppIface());
			$app->setLog		($form->getAppLog());
			$app->setRewrite	($form->getAppRewrite());

			if (($err = $app->insert($db))) {
				$form->addError	('name', $err);
				$form->reset	($request);
			}
			else $this->setForward('ok');
		}
		elseif ($form->getErrors())
			$form->reset($request);

		/* Build the authentication method list */	
		$query = "SELECT id, type, id_auth FROM auth ORDER BY id";
		$result = $db->query("$query");
		$auth = array();
	  	while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			if ($row['type'] == 1) {
				$query = "SELECT name FROM ldap WHERE id='".$row['id_auth']."'";
				$ldap_result = $db->query("$query");
				$ldap_row = $ldap_result->fetchRow(DB_FETCHMODE_ASSOC);
				array_push($auth, array('id' => $row['id'], 'name' => $ldap_row['name']));
			}
			if ($row['type'] == 2) {
				$query = "SELECT name FROM ca WHERE id='".$row['id_auth']."'";
				$ca_result = $db->query("$query");
				$ca_row = $ca_result->fetchRow(DB_FETCHMODE_ASSOC);
				array_push($auth, array('id' => $row['id'], 'name' => $ca_row['name']));
			}
	    		if ($row['type'] == 3) {
				$query = "SELECT name FROM sql WHERE id='".$row['id_auth']."'";
	      			$sql_result = $db->query("$query");
	      			$sql_row = $sql_result->fetchRow(DB_FETCHMODE_ASSOC);
	      			array_push($auth, array('id' => $row['id'], 'name' => $sql_row['name']));
	    		}
	  	}		

		/* Build the interface list */
		$query = "SELECT id, name FROM if ORDER BY name";
		$result = $db->query("$query");
		$iface = array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			array_push($iface, array('id' => $row['id'], 'name' => $row['name']));
		}
		
		/* Build the log format list */
		$query = "SELECT id, name FROM log ORDER BY name";
		$result = $db->query("$query");
		$log = array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			array_push($log, array('id' => $row['id'], 'name' => $row['name']));
		}

		/* Build the filter list */
		$query = "SELECT id, name FROM filter ORDER BY name";
		$result = $db->query("$query");
		$filter=array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			array_push($filter, array('id' => $row['id'], 'name' => $row['name']));
		}

	  	$request->setAttribute('auth', 		$auth);
	  	$request->setAttribute('iface',		$iface);
	  	$request->setAttribute('log',		$log);
	  	$request->setAttribute('filter',	$filter);
		$request->setAttribute('selected', 	stripslashes ($request->getParameter ('auth')));
		$request->setAttribute('selected_iface',stripslashes ($request->getParameter ('iface')));
		$request->setAttribute('selected_filter',$request->getParameters ('filter'));
		$request->setAttribute('name',		stripslashes ($request->getParameter ('name')));
		$request->setAttribute('alias',		stripslashes ($request->getParameter ('alias')));
		$request->setAttribute('url', 		stripslashes ($request->getParameter ('url')));
		$request->setAttribute('rewrite_rules',	stripslashes ($request->getParameter ('rewrite_rules')));
		$request->setAttribute('filter_config',	stripslashes ($request->getParameter ('filter_config')));
		$request->setAttribute('access_config', stripslashes ($request->getParameter ('access_config')));
		$request->setAttribute('errors',        $form->getErrors());
		$request->setAttribute('have_rewrite',	$form->getAppHaveRewrite());
		$request->setAttribute('have_access',	$form->getAppHaveAccess());
		$request->setAttribute('have_security',	$form->getAppHaveSecurity());
		
		$default_config = getConfig($db);
		$request->setAttribute('default_filter_config',stripslashes ($default_config['default_filter_config']));
		$request->setAttribute('default_access_config',stripslashes ($default_config['default_access_config']));

		return $this->getForward($mapping);
	}

}
	
?>
