<?
	
include_once "OpenSSL.php";
include_once "CA.php";
include_once "AbstractActionForm.php";
	
class addCAForm extends AbstractActionForm {
	
	function addCAForm() {
		parent::AbstractActionForm();
		$this->error = array();
		$this->submit = 0;
	}
	
	function setCAName($name) {
		global $i18n;
		if (!ereg('^[[:alnum:]_\.[:space:]]+$', $name)) $this->addError('name', $i18n["description"]." ".$i18n["invalid"]);
		$this->name = $name;
	}
	
	function getCAName() {
		return $this->name;
	}
	
	function setCACrt($crt) {
		$this->crt = $crt;
	}
	
	function getCACrt() {
		return $this->crt;
	}
	
	function setCAConstraint($ssl_constraint) {
		$this->ssl_constraint = $ssl_constraint;
	}

	function getCAConstraint() {
		return $this->ssl_constraint;
	}
	
	function setCARequire($ca_require) {
		$this->ca_require = $ca_require ;
	}
	
	function getCARequire() {
		return $this->ca_require;
	}
	
	function getCAID() {
		return $this->id;
	}
	
	function setCAID($id='') {
		$this->id = $id;
	}
	
	function getSubmit() {
		return $this->submit;
	}
	
	function setSubmit($submit) {
		$this->submit = $submit;
	}
	
	function reset(&$request) {
		$request->setAttribute('name', 		stripslashes ($this->getCAName()));
		$request->setAttribute('ssl_constraint',stripslashes ($this->getCAConstraint()));
		$request->setAttribute('crt', 		stripslashes ($this->getCACrt()));
		$request->setAttribute('ca_require', 	stripslashes ($this->getCARequire()));
	}
	
	function validate(&$mapping, &$request) {
	
		global $i18n;

		if ($request->getParameter('submit')) {
			$this->setCAName	($request->getParameter('name'));
			$this->setCARequire	($request->getParameter('ca_require'));
			$this->setCAConstraint	($request->getParameter('ssl_constraint'));
			$ssl = new OpenSSL();
	
			if ($request->getParameter('crt')) $ssl->setCrt($request->getParameter('crt'));

			$appConfig		=& $this->actionServer->getApplicationConfig($request);
			$controllerConfig 	=& $appConfig->getControllerConfig();
			$tmpFileDir		= $controllerConfig->getTempDir();
			$maxFileSize		= $controllerConfig->getMaxFileSize();
			$destDir 		= $tmpFileDir;
			$req 			= NULL;
			$config 		= NULL;
			$lang 			= 'en';
			$multiPartFileHandler 	=& new MultiPartUploadFileHandler($req, $config, $lang);
			$listAll 		= True;	
			$multiPartFileHandler->makeFileElements($listAll);
			$uploadedFiles 		= array();
			$uploadedFiles 		=& $multiPartFileHandler->getFileElements(); 
			$uploadError 		= '';
		
			foreach($uploadedFiles as $uploadedFile) {
				if( $uploadedFile->getFileSize() == 0 ) {
					$uploadError = 'Upload error: File sizes must be greater than zero';
					break;
				} 
				elseif( $uploadedFile->getFileSize() > $multiPartFileHandler->getMaxSize($maxFileSize) ) {
					$uploadError = 'Upload error: File sizes must not exceed '.$maxFileSize.' Bytes';
					break;
				}
			}
			if($uploadError == '') {
				$overwrite = True;
				$fileName = 'myfile';
				$moveError = '';
				$moveErrors = array();
				$moveErrors = $multiPartFileHandler->moveFiles($destDir, $overwrite);
			}

			foreach($uploadedFiles as $key => $uploadedFile) {
				$filePath = $destDir . "/" . $uploadedFile->getFileNameNew();
				$uploadedFile->setFilePath($filePath);
				if ($key == 'myfile') $ssl->setFile($filePath, $request->getParameter('pkcs12_pass'));
				$uploadedFiles[$key] = $uploadedFile;
			}
	
			$this->setCACrt($ssl->getCrt());
			if (!$this->getCACrt()) $this->addError('name', $i18n["invalid_cert"]);
		}
	
		if ($request->getParameter('id')) $this->setCAID($request->getParameter('id'));
		$request->setAttribute('ACTION_FORM', $this);
	}

}

?>
