<?
	
include_once "OpenSSL.php";
include_once "AbstractActionForm.php";
	
class addIfSSLForm extends AbstractActionForm {
	
	function addIfSSLForm() {
		parent::AbstractActionForm();
		$this->error = array();
		$this->submit = 0;
	}
	
	function setIfName($name) {
		global $i18n;
		if (!ereg('^[[:alnum:][:space:]_\.]+$', $name)) $this->addError('name', $i18n["description"]." ".$i18n["invalid"]);
		$this->name = $name;
	}
	
	function getIfName() {
		return $this->name;
	}
	
	function setIfKey($key) {
		$this->key = $key;
	}
	
	function getIfKey() {
		return $this->key;
	}
	
	function setIfCrt($crt) {
		$this->crt = $crt;
	}
	
	function getIfCrt() {
		return $this->crt;
	}
	
	function setIfChainFile($chainfile) {
		$this->chainfile = $chainfile;
	}
	
	function getIfChainFile() {
		return $this->chainfile;
	}
	
	function setIfIP($ip) {
		global $i18n;
		if (!ereg('^[[:digit:]]+\.[[:digit:]]+\.[[:digit:]]+\.[[:digit:]]+$', $ip)) $this->addError('ip', $i18n["ip_address"]." ".$i18n["invalid"]);
		$this->ip = $ip;
	}
	
	function getIfIP() {
		return $this->ip;
	}
	
	function setIfEngine ($engine) {
		$this->engine = $engine;
	}

	function getIfEngine () {
		return $this->engine;
	}

	function setIfPort($port) {
		global $i18n;
		if (!ereg('^[[:digit:]]+$', $port)) $this->addError('port', $i18n["ip_port"]." ".$i18n["invalid"]);
		$this->port = $port;
	}
	
	function getIfPort() {
		return $this->port;
	}
	
	function setIfLog($log) {
		global $i18n;
		if (!ereg('^[[:digit:]]+$', $log)) $this->addError('log', $i18n["log"]." ".$i18n["invalid"]);
		$this->log = $log;
	}
	
	function getIfLog() {
		return $this->log;
	}
	
	function getIfID() {
		return $this->id;
	}
	
	function setIfID($id='') {
		$this->id=$id;
	}
	
	function getSubmit() {
		return $this->submit;
	}
	
	function setSubmit($submit) {
		$this->submit = $submit;
	}
	
	function getIfisSSL() {
		return $this->is_ssl;
	}
	
	function setIfisSSL($flag) {
		$this->is_ssl = $flag;
	}
	
	function reset(&$request) {

		/* Build the log format list */
		$db     = $this->getDS('MyDS');
                $query = "SELECT id, name FROM log ORDER BY name";
                $result = $db->query("$query");
                $log=array();
                while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
                        array_push($log, array('id' => $row['id'], 'name' => $row['name']));
                }

		$request->setAttribute('name',		stripslashes ($this->getIfName()));
		$request->setAttribute('ip',		stripslashes ($this->getIfIP()));
		$request->setAttribute('port',		stripslashes ($this->getIfPort()));
		$request->setAttribute('log',		stripslashes ($this->getIfLog()));
		$request->setAttribute('selected_log',  stripslashes ($this->getIfLog()));
		$request->setAttribute('engine',	stripslashes ($this->getIfEngine()));
		$request->setAttribute('chainfile',	stripslashes ($this->getIfChainFile()));
		$request->setAttribute('crt',		stripslashes ($this->getIfCrt()));
		$request->setAttribute('key',		stripslashes ($this->getIfKey()));
		$request->setAttribute('is_ssl',	stripslashes ($this->getIfisSSL()));
		$request->setAttribute('id',    	$this->getIfID());
	}

	function validate(&$mapping, &$request) {
		global $i18n;

		if ($request->getParameter('submit')) {
			$this->setIfName	($request->getParameter('name'));
			$this->setIfIP		($request->getParameter('ip'));
			$this->setIfPort	($request->getParameter('port'));
			$this->setIfLog		($request->getParameter('log'));

			if ($request->getParameter('ssl')) {

				$ssl = new OpenSSL();
	
				if ($request->getParameter('engine')) 	$ssl->setEngine($request->getParameter('engine'));
				if ($request->getParameter('chainfile'))$ssl->setChainFile($request->getParameter('chainfile'));
				if ($request->getParameter('key')) 	$ssl->setKey($request->getParameter('key'));
				if ($request->getParameter('crt')) 	$ssl->setCrt($request->getParameter('crt'));
	
				$this->setIfisSSL(1);
				$appConfig	=& $this->actionServer->getApplicationConfig($request);
				$controllerConfig =& $appConfig->getControllerConfig();
				$tmpFileDir	= $controllerConfig->getTempDir();
				$maxFileSize= $controllerConfig->getMaxFileSize();
				$destDir = $tmpFileDir;
				$req = NULL;
				$config = NULL;
				$lang = 'en';
				$multiPartFileHandler =& new MultiPartUploadFileHandler($req, $config, $lang);
				$listAll = True;	
				$multiPartFileHandler->makeFileElements($listAll);
				$uploadedFiles = array();
				$uploadedFiles =& $multiPartFileHandler->getFileElements(); 
				$uploadError = '';
				foreach($uploadedFiles as $uploadedFile) {
					if($uploadedFile->getFileSize() == 0 ) {
		    				$uploadError = 'Upload error: File sizes must be greater than zero';
		    				break;
		  			} 
					elseif($uploadedFile->getFileSize() > $multiPartFileHandler->getMaxSize($maxFileSize) ) {
		    				$uploadError = 'Upload error: File sizes must not exceed '.$maxFileSize.' Bytes';
		    				break;
		  			}
				}
				if($uploadError == '') {
		  			$overwrite = True;
		  			$fileName = 'myfile';
		  			$moveError = '';
					$moveErrors = array();
					$moveErrors = $multiPartFileHandler->moveFiles($destDir, $overwrite);
				}
		
				foreach($uploadedFiles as $key => $uploadedFile) {
					$filePath = $destDir . "/" . $uploadedFile->getFileNameNew();
					$uploadedFile->setFilePath($filePath);

					if ($key == 'myfile') $ssl->setFile($filePath, $request->getParameter('pkcs12_pass'));
					$uploadedFiles[$key] = $uploadedFile;
				}

				$this->setIfEngine	($ssl->getEngine());
				$this->setIfKey		($ssl->getKey());
				$this->setIfCrt		($ssl->getCrt());
				$this->setIfChainFile	($ssl->getChainFile());

				if (!$this->getIfKey()) $this->addError('name', $i18n["invalid_key"]);
				if (!$this->getIfCrt()) $this->addError('name', $i18n["invalid_cert"]);
			}
			else $this->setIfisSSL(0);
		}

		if ($request->getParameter('id')) $this->setIfID($request->getParameter('id'));	
		$request->setAttribute('ACTION_FORM', $this );
	}

}

?>
