<?php
	
include_once "AbstractAction.php";
include_once "LDAP.php";
	
class addLDAP extends AbstractAction {
	
	function addLDAP() {
		parent::AbstractAction();
	}
	
	function execute($mapping, $form, &$request, &$response) {

		global $i18n;
		parent::execute();
	
		$this->setForward('ko');

		if ($form->getSubmit() && !$form->getErrors()) {
			$db 	= $this->getDS('MyDS');
			$ldap 	= new LDAP();

			$ldap->setName		($form->getLDAPName());
			$ldap->setAddr		($form->getLDAPAddr());
			$ldap->setPort		($form->getLDAPPort());
			$ldap->setDN		($form->getLDAPDN());
			$ldap->setPassword	($form->getLDAPPassword());
			$ldap->setBaseDN	($form->getLDAPBaseDN());
			$ldap->setUserAttr	($form->getLDAPUserAttr());
			$ldap->setGroupAttr	($form->getLDAPGroupAttr());
			$ldap->setGroupMember	($form->getLDAPGroupMember());
			$ldap->setGroupIsDN	($form->getLDAPGroupIsDN());

			if (($err = $ldap->insert($db))) {
				$form->addError	('name', $err);
				$form->reset	($request);
			}
			else $this->setForward('ok');
		}
		elseif ($form->getErrors()) $form->reset($request);

		$request->setAttribute('name', 		stripslashes ($request->getParameter ('name')));
		$request->setAttribute('ldap_addr', 	stripslashes ($request->getParameter ('ldap_addr')));
		$request->setAttribute('ldap_port', 	stripslashes ($request->getParameter ('ldap_port')));
		$request->setAttribute('ldap_dn', 	stripslashes ($request->getParameter ('ldap_dn')));
		$request->setAttribute('ldap_password', stripslashes ($request->getParameter ('ldap_password')));
		$request->setAttribute('ldap_base_dn', 	stripslashes ($request->getParameter ('ldap_base_dn')));
		$request->setAttribute('ldap_user_attr',stripslashes ($request->getParameter ('ldap_user_attr')));
		$request->setAttribute('ldap_group_attr',stripslashes ($request->getParameter ('ldap_group_attr')));
		$request->setAttribute('ldap_group_member',stripslashes ($request->getParameter ('ldap_group_member')));
		$request->setAttribute('ldap_group_is_dn',stripslashes ($request->getParameter ('ldap_group_is_dn')));
		$request->setAttribute('errors', $form->getErrors());

		return $this->getForward($mapping);
	}
}

?>
