<?

include_once "LDAP.php";	
include_once "AbstractActionForm.php";
	
class addLDAPForm extends AbstractActionForm {
	
	function addLDAPForm() {
		parent::AbstractActionForm();
		$this->error = array();
		$this->submit = 0;
	}
	
	function setLDAPName($name) {
		global $i18n;
		if (!ereg('^[[:alnum:][:space:]_\.]+$', $name)) $this->addError('name', $i18n["description"]." ".$i18n["invalid"]);
		$this->name = $name;
	}
	function getLDAPName() {
		return $this->name;
	}
	
	function setLDAPAddr($ldap_addr) {
		global $i18n;
		if (!ereg('^[[:digit:]]+\.[[:digit:]]+\.[[:digit:]]+\.[[:digit:]]+$', $ldap_addr)) $this->addError('ldap_addr', $i18n["ldap_addr"]." ".$i18n["invalid"]);
		$this->ldap_addr = $ldap_addr;
	}
	function getLDAPAddr() {
		return $this->ldap_addr;
	}
	
	function setLDAPPort ($ldap_port) {
		global $i18n;
		if (!ereg('^[[:digit:]]+$', $ldap_port)) $this->addError('ldap_port', $i18n["ldap_port"]." ".$i18n["invalid"]);
		$this->ldap_port = $ldap_port;
	}
	function getLDAPPort() {
		return $this->ldap_port;
	}
	
	function setLDAPDN($ldap_dn) {
		global $i18n;
		if ($ldap_dn=="") $this->addError('ldap_dn', $i18n["ldap_dn"]." ".$i18n["invalid"]);
		$this->ldap_dn = $ldap_dn;
	}
	function getLDAPDN() {
		return $this->ldap_dn;
	}

	function setLDAPBaseDN($ldap_base_dn) {
		global $i18n;
		if ($ldap_base_dn=="") $this->addError('ldap_base_dn', $i18n["ldap_base_dn"]." ".$i18n["invalid"]);
		$this->ldap_base_dn = $ldap_base_dn;
	}
	function getLDAPBaseDN() {
		return $this->ldap_base_dn;
	}

	function setLDAPPassword($ldap_password) {
		$this->ldap_password = $ldap_password;
	}
	function getLDAPPassword() {
		return $this->ldap_password;
	}

	function setLDAPUserAttr($ldap_user_attr) {
		global $i18n;
		if (!ereg('^[[:alnum:]]+$', $ldap_user_attr)) $this->addError('ldap_user_attr', $i18n["ldap_user_attr"]." ".$i18n["invalid"]);
		$this->ldap_user_attr = $ldap_user_attr;
	}
	function getLDAPUserAttr() {
		return $this->ldap_user_attr;
	}
	
	function setLDAPGroupAttr($ldap_group_attr) {
		global $i18n;
		if (!ereg('^[[:alnum:]]+$', $ldap_group_attr)) $this->addError('ldap_group_attr', $i18n["ldap_group_attr"]." ".$i18n["invalid"]);
		$this->ldap_group_attr = $ldap_group_attr;
	}
	function getLDAPGroupAttr() {
		return $this->ldap_group_attr;
	}
	
	function setLDAPGroupMember($ldap_group_member) {
		global $i18n;
		if (!ereg('^[[:alnum:]]+$', $ldap_group_member)) $this->addError('ldap_group_member', $i18n["ldap_group_member"]." ".$i18n["invalid"]);
		$this->ldap_group_member = $ldap_group_member;
	}
	function getLDAPGroupMember() {
		return $this->ldap_group_member;
	}

	function setLDAPGroupIsDN($flag) {
		$this->ldap_group_is_dn = $flag;
	}

	function getLDAPGroupIsDN() {
		return $this->ldap_group_is_dn;
	}
	
	
	function getLDAPID() {
		return $this->id;
	}
	
	function setLDAPID($id) {
		$this->id = $id;
	}

	function setLDAPGroupOK($ok_g) {
		$this->ok_g = $ok_g;
	}

	function setLDAPGroupKO($ko_g) {
		$this->ko_g = $ko_g;
	}

	function getLDAPGroupOK() {
		return $this->ok_g;
	}

	function getLDAPGroupKO() {
		return $this->ko_g;
	}

	function setLDAPUserOK($ok) {
		$this->ok = $ok;
	}

	function setLDAPUserKO($ko) {
		$this->ko = $ko;
	}

	function getLDAPUserOK() {
		return $this->ok;
	}

	function getLDAPUserKO() {
		return $this->ko;
	}

	function getIsACL() {
		return $this->is_acl;
	}

	function setIsACL($is_acl) {
		$this->is_acl = $is_acl;
	}

	function getIsACLSubmit() {
		return $this->is_acl_submit;
	}

	function setIsACLSubmit($is_acl_submit) {
		$this->is_acl_submit = $is_acl_submit;
	}
	
	function getSubmit() {
		return $this->submit;
	}
	
	function setSubmit($submit) {
		$this->submit = $submit;
	}
	
	function reset(&$request) {
		$request->setAttribute('name',			stripslashes ($this->getLDAPName()));
		$request->setAttribute('ldap_addr',		stripslashes ($this->getLDAPAddr()));
		$request->setAttribute('ldap_port',		stripslashes ($this->getLDAPPort()));
		$request->setAttribute('ldap_dn',		stripslashes ($this->getLDAPDN()));
		$request->setAttribute('ldap_password',		stripslashes ($this->getLDAPPassword()));
		$request->setAttribute('ldap_base_dn',		stripslashes ($this->getLDAPBaseDN()));
		$request->setAttribute('ldap_user_attr',	stripslashes ($this->getLDAPUserAttr()));
		$request->setAttribute('ldap_group_attr',	stripslashes ($this->getLDAPGroupAttr()));
		$request->setAttribute('ldap_group_member',	stripslashes ($this->getLDAPGroupMember()));
		$request->setAttribute('ldap_group_is_dn',	stripslashes ($this->getLDAPGroupIsDN()));
		$request->setAttribute('id',    		$this->getLDAPID());
		$request->setAttribute('acl',    		$this->getIsACL());
	}

	function validate(&$mapping, &$request) {
		if ($request->getParameter('acl')) {
			$this->setIsACL(1);
		}
		if ($request->getParameter('submit')) {
			if ($request->getParameter('add_ldap')) {
				$this->setLDAPUserOK($request->getParameters('avail_ldap'));
				$this->setIsACL(1);
				$this->setIsACLSubmit(1);
			}
			if ($request->getParameter('remove_ldap')) {
				$this->setLDAPUserKO($request->getParameters('in_ldap'));
				$this->setIsACLSubmit(1);
				$this->setIsACL(1);
			}
			if ($request->getParameter('add_ldap_g')) {
				$this->setLDAPGroupOK($request->getParameters('avail_ldap_g'));
				$this->setIsACL(1);
				$this->setIsACLSubmit(1);
			}
			if ($request->getParameter('remove_ldap_g')) {
				$this->setLDAPGroupKO($request->getParameters('in_ldap_g'));
				$this->setIsACLSubmit(1);
				$this->setIsACL(1);
			}
			$this->setLDAPName	 ($request->getParameter('name'));
			$this->setLDAPAddr	 ($request->getParameter('ldap_addr'));
			$this->setLDAPPort	 ($request->getParameter('ldap_port'));
			$this->setLDAPDN	 ($request->getParameter('ldap_dn'));
			$this->setLDAPPassword	 ($request->getParameter('ldap_password'));
			$this->setLDAPBaseDN	 ($request->getParameter('ldap_base_dn'));
			$this->setLDAPUserAttr	 ($request->getParameter('ldap_user_attr'));
			$this->setLDAPGroupAttr	 ($request->getParameter('ldap_group_attr'));
			$this->setLDAPGroupMember($request->getParameter('ldap_group_member'));
			$this->setLDAPGroupIsDN  ($request->getParameter('ldap_group_is_dn'));
		}
		if ($request->getParameter('id')) 	$this->setLDAPID($request->getParameter('id'));
	
		$request->setAttribute('ACTION_FORM', $this );
	}

}

?>
