<?php

include_once "AbstractAction.php";
include_once "Utils.php";
include_once "App.php";

define('LDAP',	1);
define('CA',	2);
define('SQL',	3);

class editApp extends AbstractAction {

	function editApp() {
		parent::AbstractAction();
	}
		
	function execute($mapping, $form, &$request, &$response) {
		global $i18n;
		parent::execute();
	
		$this->setForward('ko');
	
		$app	= new App();
		$db	= $this->getDS('MyDS');

		if ($header_id = $form->getAppHeaderID()) {
			$form->setAppHasHeaders(1);
			if ($header_var = $form->getAppHeaderVar()) {
				$query = "UPDATE headers SET
					  var='".sqlite_escape_string($header_var)."',
					  value='".sqlite_escape_string($form->getAppHeaderValue())."' 
					  WHERE id='".sqlite_escape_string($header_id)."'";
			}
			else {
				$query = "DELETE FROM headers WHERE id='".sqlite_escape_string($header_id)."'";
			}
 			$result = $db->query($query);
			if (DB::isError($result)) {
                         	print "Error: " . __FUNCTION__ . "() in " . __FILE__;
                         	print_r($result);
                         	return TRUE;
			}
		}
		elseif ($header_var = $form->getAppHeaderVar()) {
			$query = "INSERT INTO headers (id_app, var, value)
				  VALUES('".
				sqlite_escape_string($form->getAppID())."', '".
				sqlite_escape_string($header_var)."', '".
				sqlite_escape_string($form->getAppHeaderValue()).
				"')";

			$result = $db->query($query);
			if (DB::isError($result)) {
				print "Error: " . __FUNCTION__ . "() in " . __FILE__;
				print_r($result);
				return TRUE;
			}
		}

		$app->select($db, $form->getAppID());

		/* Build the authentication method list */
		$query = "SELECT id, type, id_auth FROM auth ORDER BY id";
		$result = $db->query($query);
		$auth = array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			if ($row['type'] == LDAP) {
				$query = "SELECT name FROM ldap WHERE id='".$row['id_auth']."'";
				$ldap_result = $db->query("$query");
				$ldap_row = $ldap_result->fetchRow(DB_FETCHMODE_ASSOC);
				array_push($auth, array('id' => $row['id'], 'name' => $ldap_row['name']));
			}
			if ($row['type'] == CA) {
				$query = "SELECT name FROM ca WHERE id='".$row['id_auth']."'";
				$ca_result = $db->query("$query");
				$ca_row = $ca_result->fetchRow(DB_FETCHMODE_ASSOC);
				array_push($auth, array('id' => $row['id'], 'name' => $ca_row['name']));
			}
	    		if ($row['type'] == SQL) {
				$query = "SELECT name FROM sql WHERE id='".$row['id_auth']."'";
	      			$sql_result = $db->query("$query");
	      			$sql_row = $sql_result->fetchRow(DB_FETCHMODE_ASSOC);
	      			array_push($auth, array('id' => $row['id'], 'name' => $sql_row['name']));
	    		}
		}
		/* Build the interface list */
		$query = "SELECT id, name FROM if ORDER BY name";
		$result = $db->query($query);
		$iface = array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			array_push($iface, array('id' => $row['id'], 'name' => $row['name']));
		}
		
		/* Build the log format list */
		$query = "SELECT id, name FROM log ORDER BY name";
		$result = $db->query($query);
		$log = array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			array_push($log, array('id' => $row['id'], 'name' => $row['name']));
		}


		/* Build the filter list */
		$query = "SELECT id, name FROM filter ORDER BY name";
		$result = $db->query($query);
		$filter = array();
		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			array_push($filter, array('id' => $row['id'], 'name' => $row['name']));
		}

		$request->setAttribute('id', $form->getAppID());

		if ($form->getIsAddPost()) {
			/* Add the variable into table post */
			$query = "INSERT INTO post (id_app, field_desc, field_var, field_type, field_value) VALUES('".$form->getAppID()."', '".$form->getFieldDesc()."','".$form->getFieldVar()."', '".$form->getFieldType()."', '".$form->getFieldValue()."')";
			$result = $db->query($query);
			$app->setIsPost ($form->getAppIsPost() ? 1 : 0);
			if (($err = $app->update($db))) {
				$form->addError('post', $err);
			}
		}
		elseif ($form->getIsDelPost()) {
			/* Delete a variable from post */
			$query = "DELETE FROM post WHERE id='".$form->getIsDelPost()."'";
			$result = $db->query($query);
			$app->setIsPost ($form->getAppIsPost() ? 1 : 0);
			if (($err = $app->update($db))) {
				$form->addError('post', $err);
			}
		}
	
		/* Build the POST variable list */
		$query = "SELECT p.id, p.field_desc, p.field_var, p.field_type, p.field_value FROM post p, app a WHERE a.id = p.id_app AND a.id='".$form->getAppID()."'";
		$result = $db->query($query);
		$post_vars = array();

		while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
			array_push($post_vars, array('id'		=> stripslashes($row['p.id']),
						     'field_desc'	=> stripslashes($row['p.field_desc']),
						     'field_var'	=> stripslashes($row['p.field_var']),
						     'field_type'	=> stripslashes($row['p.field_type']),
						     'field_value'	=> stripslashes($row['p.field_value'])
						     ));
		}
		$request->setAttribute('post_vars',	$post_vars);

		if ($form->getSubmit() || $form->getIsAddPost() || $form->getIsDelPost()) {
			$app->setAutoLogon 	($form->getAppAutoLogon());

			if ($form->getAppIsPost()) {
				$app->setSSOForwardType ($form->getAppSSOForwardType());
				$app->setIsPost		(1);
				$app->setPostUrl	($form->getPostUrl());
			}
			else {	
				$app->setSSOForwardType ("");
				$app->setIsPost		(0);
			}
		}

		if ($form->getSubmit() && 
		    !$form->getErrors() &&
		    !$form->getIsAddPost() &&
		    !$form->getIsDelPost() &&
		    !($form->getAppHeaderVar() || $form->getAppHeaderID())
		    ) {

			$app->setName	($form->getAppName());
			$app->setAlias	($form->getAppAlias());
			$app->setUrl	($form->getAppUrl());
			$app->setAuth	($form->getAppAuth());
			$app->setIface	($form->getAppIface());
			$app->setLog	($form->getAppLog());

			$app->setHasHeaders($form->getAppHasHeaders());			
			if ($form->getAppHaveRewrite())
				$app->setRewrite($form->getAppRewrite());
			else
				$app->setRewrite("");
			
			if ($form->getAppHaveAccess())
				$app->setAccessConfig($form->getAppAccessConfig());
			else
				$app->setAccessConfig("");
			
			if ($form->getAppHaveSecurity())	{
				$app->setFilter($form->getAppFilter());
				$app->setFilterConfig($form->getAppFilterConfig());
			}
			else {
				$app->setFilter("");
				$app->setFilterConfig("");
			}
		
			if (($err = $app->update($db))) {
				$form->addError('name', $err);
				$form->reset($request);
			}
			else {
				$this->setForward('ok');
			}
		}
		elseif ($form->getErrors()) {
			$form->reset($request);
		}
		else {
			if ($form->getAppHeaderVar() || $form->getAppHeaderID()) {
				$app->setHasHeaders($form->getAppHasHeaders());

				if (($err = $app->update($db))) {
					$form->addError('name', $err);
				}
			}
			$request->setAttribute('auth',		$auth);
			$request->setAttribute('iface',		$iface);
			$request->setAttribute('log',		$log);
			$request->setAttribute('filter',	$filter);
			$request->setAttribute('filter_config',	$app->getFilterConfig());
			$request->setAttribute('access_config',	$app->getAccessConfig());
			$request->setAttribute('selected',	$app->getAuth());
			$request->setAttribute('selected_iface',$app->getIface());
			$request->setAttribute('selected_log', 	$app->getLog());
			$request->setAttribute('selected_filter',$app->getFilter());
			$request->setAttribute('name',		$app->getName());
			$request->setAttribute('alias',		$app->getAlias());
			$request->setAttribute('url',		$app->getUrl());
			$request->setAttribute('is_post',	$app->getIsPost());
			$request->setAttribute('post_url',	$app->getPostUrl());
			$request->setAttribute('sso_forward_type', $app->getSSOForwardType());
			$request->setAttribute('autologon', 	$app->getAutoLogon());
			$request->setAttribute('rewrite_rules',	$app->getRewrite());
			$request->setAttribute('headers', 	$app->getHeaders());
			$request->setAttribute('has_headers',	($app->getHasHeaders()) ? 1 : 0);
			$request->setAttribute('have_rewrite',	($app->getRewrite()) ? 1 : 0);
			$request->setAttribute('have_access',	($app->getAccessConfig()) ? 1 : 0);
			$request->setAttribute('have_security',	($app->getFilter() || $app->getFilterConfig()) ? 1 : 0);

			$default_config = getConfig($db);
                	$request->setAttribute('default_filter_config',stripslashes ($default_config['default_filter_config']));
                	$request->setAttribute('default_access_config',stripslashes ($default_config['default_access_config']));
		}

		$request->setAttribute('errors',	$form->getErrors());
	
		return $this->getForward($mapping);
	}
	
}
	
?>
