<?php
	
include_once "AbstractAction.php";
include_once "If.php";
	
class editIfSSL extends AbstractAction {
	
	function editIfSSL() {
		parent::AbstractAction();
	}
	
	function execute($mapping, $form, &$request, &$response) {
	
		global $i18n;
		parent::execute();
	
		$this->setForward('ko');

		$if = new Intf();
		$db = $this->getDS('MyDS');
		$if->select($db, $form->getIfID());

		/* Build the log format list */
                $query = "SELECT id, name FROM log ORDER BY name";
                $result = $db->query($query);
                $log = array();
                while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
                        array_push($log, array('id' => $row['id'], 'name' => $row['name']));
                }

		if ($form->getSubmit() && !$form->getErrors()) {
		
			$if->setName($form->getIfName());
			$if->setIP($form->getIfIP());
			$if->setPort($form->getIfPort());
			$if->setLog($form->getIfLog());
			if ($form->getIfisSSL()) {
				$if->setEngine		($form->getIfEngine());
				$if->setCrt		($form->getIfCrt());
				$if->setKey		($form->getIfKey());
				$if->setChainFile	($form->getIfChainFile());
			}
			else {
				$if->setCrt();
				$if->setKey();
				$if->setEngine();
				$if->setChainFile();
			}

			if (($err = $if->update($db))) {
				$form->addError('name', $err);
				$form->reset($request);
			}
			else $this->setForward('ok');
		}
		elseif ($form->getErrors()) $form->reset($request);
		else {
			$request->setAttribute('name',		$if->getName());
			$request->setAttribute('ip',		$if->getIP());
			$request->setAttribute('port',		$if->getPort());
			$request->setAttribute('log',           $log);
			$request->setAttribute('selected_log',  stripslashes ($if->getLog()));
			$request->setAttribute('crt',		$if->getCrt());
			$request->setAttribute('chainfile',	$if->getChainFile());
			$request->setAttribute('engine',	$if->getEngine());
			$request->setAttribute('key',		$if->getKey());
			$request->setAttribute('is_ssl',	($if->getKey() && $if->getCrt()) ? 1 : 0);
			$request->setAttribute('id',		$if->getID());
			$this->setForward('ko');
		}

		$request->setAttribute('errors', $form->getErrors());

		return $this->getForward($mapping);
	}
}
	
?>
