<?php
	
include_once "AbstractAction.php";
include_once "LDAP.php";
include_once "ACL.php";
	
class editLDAP extends AbstractAction {
	
	function editLDAP() {
		parent::AbstractAction();
	}
	
	function execute($mapping, $form, &$request, &$response) {

		global $i18n;
		parent::execute();
	
		$this->setForward('ko');

		$ldap	= new LDAP();
		$db 	= $this->getDS('MyDS');
		$ldap->select($db, $form->getLDAPID());

		$acl = $ldap->getACL($db);

		if ($form->getIsACL()) {
			$request->setAttribute('acl', $form->getIsACL());
		}
		else {
			$request->setAttribute('acl', $ldap->getIsACL());
		}
		if ($form->getIsACLSubmit() && $form->getLDAPUserOK() || $form->getLDAPUserKO() || $form->getLDAPGroupOK() || $form->getLDAPGroupKO()) {
			$acl->setLDAPUserOK($form->getLDAPUserOK());
			$acl->setLDAPUserKO($form->getLDAPUserKO());
			$acl->setLDAPGroupOK($form->getLDAPGroupOK());
			$acl->setLDAPGroupKO($form->getLDAPGroupKO());
			$ldap->setIsACL(1);
			$ldap->update($db);
			$request->setAttribute('id', $ldap->getID());
			$form->reset($request);
			$this->setForward('ko');
		}
		elseif ($form->getSubmit() && !$form->getErrors()) {
			$ldap->setName          ($form->getLDAPName());
			$ldap->setAddr          ($form->getLDAPAddr());
			$ldap->setPort          ($form->getLDAPPort());
			$ldap->setDN            ($form->getLDAPDN());
			$ldap->setPassword      ($form->getLDAPPassword());
			$ldap->setBaseDN        ($form->getLDAPBaseDN());
			$ldap->setUserAttr      ($form->getLDAPUserAttr());
			$ldap->setGroupMember   ($form->getLDAPgroupMember());
			$ldap->setGroupIsDN     ($form->getLDAPgroupIsDN());
			$ldap->setGroupAttr     ($form->getLDAPGroupAttr());
			$ldap->setIsACL		($form->getIsACL());

			if ($err = $ldap->update($db)) {
				$form->addError('name', $err);
				$form->reset($request);
			}
			else $this->setForward('ok');
		}
		elseif ($form->getErrors()) $form->reset($request);
		else {
			$request->setAttribute('name', 			$ldap->getName());
			$request->setAttribute('ldap_addr', 		$ldap->getAddr());
			$request->setAttribute('ldap_port', 		$ldap->getPort());
			$request->setAttribute('ldap_dn', 		$ldap->getDN());
			$request->setAttribute('ldap_password', 	$ldap->getPassword());
			$request->setAttribute('ldap_base_dn', 		$ldap->getBaseDN());
			$request->setAttribute('ldap_user_attr', 	$ldap->getUserAttr());
			$request->setAttribute('ldap_group_attr', 	$ldap->getGroupAttr());
			$request->setAttribute('ldap_group_member', 	$ldap->getGroupMember());
			$request->setAttribute('ldap_group_is_dn', 	$ldap->getGroupIsDN());
			$request->setAttribute('id',            	$ldap->getID());
		}
		if ($form->getIsACL() || $ldap->getIsACL()) {
			$request->setAttribute('acl_ok', $acl->getLDAPUserOK());
			$request->setAttribute('acl_ko', $acl->getLDAPUserKO());
			$request->setAttribute('acl_ok_g', $acl->getLDAPGroupOK());
			$request->setAttribute('acl_ko_g', $acl->getLDAPGroupKO());
		}
		$request->setAttribute('errors', $form->getErrors());

		return $this->getForward($mapping);
	}
}

?>
