<?php
/* OOH! Forms! Extensions
* Author: John C. Wildenauer
* Date	: 24 Oct 2002
* Copyright (c) 2002 by John C. Wildenauer
* 
* oohforms_ext.inc,v 1.0 200210241650
* 
* pop_start()
* - modified start function for pop-up window use
* 
* pop_finish()
* - modified finish function for pop-up window use
*   eg: not using start(), or <form ...> ... </form>
* 
* ext_validate()
* - added error table row array 
* 
* class of_button
* - added class of_button
*   a general purpose button (for Javascript function actions)
* 
*/


/**
* Class of_button
* A general purpose button (for Javascript function actions)
*
*/
class of_button extends of_element {

	var $src;

	// Constructor
	function of_button($a) {    
		$this->setup_element($a);
	}

	function self_get($val, $which, &$count) {

		$str = "";

		$sv = empty($val) ? $this->value : $val;
		$str .= "<input name='$this->name' value='$sv'";

		if ($this->src) 
			$str .= " type='image' src='$this->src'";
		else 
			$str .= " type='button'";
		
		if ($this->extrahtml) 
			$str .= " $this->extrahtml";

		$str .= ">";
    
		return $str;

	}
  
	function self_load_defaults($val) {
		// POP_BUTTON will not change its value
	}

} // end POP_BUTTON



/**
* Class OOHFormExt
* Add extended functionality to the 'form' class
*
*/
class OOHFormExt extends form {

	/**
	*  pop_start()
	*  A modified start function for pop-up window use
	*  Note: need to still use <form..> to reference the form elements
	*
	*/
	function pop_start($jvs_name="", $form_name="") {

		global $PHP_SELF;
		
		$str = "";
		$this->jvs_name = "";
		$this->n = 0;
		$str .= "<form name='$form_name' >";
		
		if ($jvs_name){
			$this->jvs_name = $jvs_name;
		}
		
		return $str;
	}


	/**
	*  pop_finish()
	*  A modified start function for pop-up window use
	*
	*/
	function pop_finish($jvs_name="", $after="",$before="") {

		global $sess;
		$str = "";
		
		if ($this->hidden) {
			reset($this->hidden);
			while (list($k,$elname) = each($this->hidden)) 
				$str .= $this->get_element($elname);
		}
		if (is_object($sess) && ($sess->mode == "get")) {
			$str .= sprintf("<input type=\"hidden\" name=\"%s\" value=\"%s\">\n", $sess->name, $sess->id);
		}
		$str .= "</form>\n\n";
		
		if ($this->jvs_name) {
			$jvs_name = $this->jvs_name;
			$str .= "<script language='javascript'>\n<!--\n";
			$str .= "function ${jvs_name}_Validator(f) {\n";
			
			if (strlen($before))
				$str .= "$before\n";

			reset($this->elements);

			while (list($k,$elrec) = each($this->elements)) {
				$el = $elrec["ob"];
				$str .= $el->self_get_js($elrec["ndx_array"]);
			}

			if (strlen($after))
				$str .= "$after\n";

			$str .= "}\n//-->\n</script>";
		}

		return $str;

	}

  
	/*
	* ext_validate(...)
	
	* Adds error table row array
	* From the PHP mailing list
	* 
	* "... a question concerning validate() function in oohforms.inc.
	* Does anybody know how to force validate() report ALL errors and then
	* load_defaults()? By default validate() returns first occurred error 
	* and you should resubmit form many times if you have more then 1 error."
	* From the CVS.
	* 
	* {{{ function ext_validate(...) }}}
	* public: array($error_msg, array $error_flag)
	*       = ext_validate(mixed $default, mixed $vallist, string $delimiter )
	* serverside validate that gives you an array indexed by the element name
	* 
	*/
	function ext_validate($default=false, $vallist="", $delimiter="\n") {
		// convert vallist to array in necessary
		if ("" != $vallist && !is_array($vallist))
			$vallist = array ($vallist);

		// fallback to all elements
		if (!is_array($vallist))
			$vallist = $this->elements;

		//$error_flags= array();
		$errors	= array();

		while(list($elname, $v) = each($vallist)) {
			// does this element exist?
			if(isset($this->elements[$elname])) {

				$el = $this->elements[$elname]["ob"];

				if($res = $el->marshal_dispatch($this->method, "self_validate")) {
					// build the error table row

					$e_tr = 
						"<tr>
				      	<td colspan=5 class='error'>
								$res
				      	</td>
				   	</tr>
						";
					
					$errors[$elname] = $e_tr;
				}
			}
		} // while(...)
	
   	return $errors;	// array(element_tag => error_message_tr)

	} // end func ext_validate



} /* end clas FORM */



?>